/**
 * DuMP3 version 0.3.2 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Observable;
import java.util.Observer;
import java.util.Set;

import net.za.grasser.duplicate.compare.Comparer;
import net.za.grasser.duplicate.file.DirectoryInfo;
import net.za.grasser.duplicate.file.DirectoryReader;
import net.za.grasser.duplicate.file.ExtensionCount;
import net.za.grasser.duplicate.file.FingerprintFile;
import net.za.grasser.duplicate.file.WildcardFilter;
import net.za.grasser.duplicate.fingerprint.AbstractFingerprint;
import net.za.grasser.duplicate.fingerprint.ColorFingerprint;
import net.za.grasser.duplicate.fingerprint.FdmfFingerprint;
import net.za.grasser.duplicate.fingerprint.FingerprintFactory;
import net.za.grasser.duplicate.fingerprint.SifFingerprint;
import net.za.grasser.duplicate.fingerprint.SubstringFingerprint;
import net.za.grasser.duplicate.gui.CollectionTableContentProvider;
import net.za.grasser.duplicate.gui.ExtensionCountSorter;
import net.za.grasser.duplicate.gui.FileListLabelProvider;
import net.za.grasser.duplicate.gui.FileTreeContentProvider;
import net.za.grasser.duplicate.gui.FileTreeLabelProvider;
import net.za.grasser.duplicate.gui.FingerprintTableLabelProvider;
import net.za.grasser.duplicate.gui.FingerprintTreeContentProvider;
import net.za.grasser.duplicate.gui.FingerprintTreeLabelProvider;
import net.za.grasser.duplicate.gui.IDisplay;
import net.za.grasser.duplicate.gui.ListTreeContentProvider;
import net.za.grasser.duplicate.gui.StringSorter;
import net.za.grasser.duplicate.gui.TypeTableLabelProvider;
import net.za.grasser.duplicate.gui.config.ConfigContentProvider;
import net.za.grasser.duplicate.gui.config.ConfigLabelProvider;
import net.za.grasser.duplicate.gui.display.DoubleDisplay;
import net.za.grasser.duplicate.gui.display.DoubleDisplayFactory;
import net.za.grasser.duplicate.gui.events.HotKeyListener;
import net.za.grasser.duplicate.gui.file.FileUtils;
import net.za.grasser.duplicate.gui.info.DoubleInfo;
import net.za.grasser.duplicate.persist.DatabaseFactory;
import net.za.grasser.duplicate.util.Chars;
import net.za.grasser.duplicate.util.Files;
import net.za.grasser.duplicate.util.Strings;
import net.za.grasser.duplicate.util.Version;
import net.za.grasser.duplicate.util.res.Debug;
import net.za.grasser.duplicate.util.res.Messages;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;
import org.eclipse.jface.viewers.AbstractTreeViewer;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Link;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Sash;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.swt.widgets.TreeColumn;

import com.cloudgarden.resource.SWTResourceManager;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose whatever) then you should purchase a license for each developer using Jigloo. Please
 * visit www.cloudgarden.com for details. Use of Jigloo implies acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR THIS
 * MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.84 $
 */
public class DuMP3 extends org.eclipse.swt.widgets.Composite implements Observer, IDisplay {
  /**
   * <code>ANCHOR_DOWNLOAD_DUMP3</code> DuMP3 -
   */
  private static final String ANCHOR_DOWNLOAD_DUMP3 = "<a href=\"http://sourceforge.net/project/showfiles.php?group_id=100118\">"; //$NON-NLS-1$
  /**
   * <code>ANCHOR_END</code> DuMP3 -
   */
  private static final String ANCHOR_END = "</a>"; //$NON-NLS-1$
  /**
   * <code>display</code> DuMP3 -
   */
  private static Display display = null;
  /**
   * <code>HORIZONTAL_LAYOUT</code> DuMP3 -
   */
  private static final String HORIZONTAL_LAYOUT = "horizontal layout"; //$NON-NLS-1$
  /**
   * <code>horizontalLayout</code> DuMP3 - Changes the layout of the result page.
   */
  private static boolean horizontalLayout;
  /**
   * <code>IMAGE</code> DuMP3 -
   */
  private static final String IMAGE = "image"; //$NON-NLS-1$
  /**
   * <code>listener</code> DuMP3 -
   */
  private static final HotKeyListener listener = HotKeyListener.getInstance();
  /**
   * <code>log</code> DuMP3 -
   */
  private static Logger log;
  /**
   * <code>PROPERTY</code> DuMP3 -
   */
  private static final String PROPERTY = "property"; //$NON-NLS-1$
  /**
   * <code>TEXT</code> DuMP3 -
   */
  private static final String TEXT = "text"; //$NON-NLS-1$
  /**
   * <code>VALUE</code> DuMP3 -
   */
  private static final String VALUE = "value"; //$NON-NLS-1$
  /**
   * <code>VERSION</code> DuMP3 -
   */
  private static final String VERSION = "0.3.2"; //$NON-NLS-1$
  static {
    Configure.load();
    PropertyConfigurator.configure(Files.LOG4J);
    log = Logger.getLogger(DuMP3.class);
    horizontalLayout = Configure.getBooleanProperty(HORIZONTAL_LAYOUT, false, DuMP3.class.getName());
  }
  /**
   * Converts String to Double.
   * 
   * @param pD
   * @return a string representation of the double
   */
  static final String cut(final double pD) {
    String s = String.valueOf(pD);
    if (s.indexOf(Chars.DOT) > 0) {
      int l = s.substring(s.indexOf(Chars.DOT)).length();
      if (l > 3) {
        l = 3;
      }
      s = s.substring(0, s.indexOf(Chars.DOT) + l);
    }
    return s;
  }

  /**
   * This method should return an instance of this class which does NOT initialize it's GUI elements. This method is ONLY required by Jigloo if the superclass
   * of this class is abstract or non-public. It is not needed in any other situation.
   * 
   * @param parent
   * @param style
   * @return instance of this class which does NOT initialize it's GUI elements
   */
  public static Object getGUIBuilderInstance(final org.eclipse.swt.widgets.Composite parent, final int style) {
    return new DuMP3(parent, style, Boolean.FALSE);
  }

  /**
   * Auto-generated main method to display this org.eclipse.swt.widgets.Composite inside a new Shell.
   * 
   * @param args
   */
  public static void main(final String[] args) {
    if (log.isDebugEnabled()) {
      final List<Object> replace = new ArrayList<Object>();
      replace.add(DuMP3.class.getSimpleName());
      replace.add(VERSION);
      log.debug(Debug.getString(DuMP3.class, 1, replace));
    }
    final SplashScreen s = new SplashScreen(0);
    s.showSplash();
    display = Display.getDefault();
    if (log.isDebugEnabled()) {
      final List<Object> replace = new ArrayList<Object>();
      replace.add(display.getClass().getSimpleName());
      log.debug(Debug.getString(DuMP3.class, 2, replace));
    }
    final Shell shell = new Shell(display);
    if (log.isDebugEnabled()) {
      final List<Object> replace = new ArrayList<Object>();
      replace.add(shell.getClass().getSimpleName());
      log.debug(Debug.getString(DuMP3.class, 3, replace));
    }
    final DuMP3 inst = new DuMP3(shell, SWT.NULL);
    if (log.isDebugEnabled()) {
      final List<Object> replace = new ArrayList<Object>();
      replace.add(inst.getClass().getSimpleName());
      log.debug(Debug.getString(DuMP3.class, 4, replace));
    }
    final Point size = inst.getSize();
    shell.setLayout(new FillLayout());
    final List<Object> rep = new ArrayList<Object>();
    rep.add(DuMP3.class.getSimpleName());
    shell.setText(Messages.getString(DuMP3.class, 5, rep));
    shell.setImage(SWTResourceManager.getImage(Files.ICONS_MAIN_ICO));
    shell.layout();
    if ((size.x == 0) && (size.y == 0)) {
      inst.pack();
      shell.pack();
    } else {
      final Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
      shell.setSize(shellBounds.width, shellBounds.height);
    }
    if (log.isDebugEnabled()) {
      final List<Object> replace = new ArrayList<Object>();
      replace.add(shell.getClass().getSimpleName());
      log.debug(Debug.getString(DuMP3.class, 6, replace));
    }
    shell.open();
    if (log.isDebugEnabled()) {
      final List<Object> replace = new ArrayList<Object>();
      replace.add(shell.getClass().getSimpleName());
      log.debug(Debug.getString(DuMP3.class, 7, replace));
    }
    DatabaseFactory.getDatabase().isConnected();
    s.hideSplash();
    while (!shell.isDisposed()) {
      if (!display.readAndDispatch()) {
        display.sleep();
      }
    }
    if (log.isDebugEnabled()) {
      log.debug(Debug.getString(DuMP3.class, 8));
    }
    DatabaseFactory.getDatabase().close();
    if (log.isDebugEnabled()) {
      log.debug(Debug.getString(DuMP3.class, 9));
    }
    // make sure all swing components are closed.
    System.exit(0);
  }

  /**
   * This method returns a compare speed
   * 
   * @param pProgress
   * @param pStartSpeed
   * @return String
   */
  static final String speed(final double pProgress, final Date pStartSpeed) {
    final double diff = new Date().getTime() - pStartSpeed.getTime();
    if (diff == 0.0) {
      return Messages.getString(DuMP3.class, 65);
    }
    String t = Messages.getString(DuMP3.class, 57);
    double f = pProgress / diff;
    if (f < 1.0 / 3153600000.0) {
      f = pProgress * 31536000000.0 / diff;
      t = Messages.getString(DuMP3.class, 64);
    } else if (f < 1.0 / 263520000.0) {
      f = pProgress * 2635200000.0 / diff;
      t = Messages.getString(DuMP3.class, 63);
    } else if (f < 1.0 / 60480000.0) {
      f = pProgress * 604800000.0 / diff;
      t = Messages.getString(DuMP3.class, 62);
    } else if (f < 1.0 / 8640000.0) {
      f = pProgress * 86400000.0 / diff;
      t = Messages.getString(DuMP3.class, 61);
    } else if (f < 1.0 / 360000.0) {
      f = pProgress * 3600000.0 / diff;
      t = Messages.getString(DuMP3.class, 60);
    } else if (f < 1.0 / 6000.0) {
      f = pProgress * 60000.0 / diff;
      t = Messages.getString(DuMP3.class, 59);
    } else if (f < 1.0 / 100.0) {
      f = pProgress * 1000.0 / diff;
      t = Messages.getString(DuMP3.class, 58);
    }
    final List<String> replace = new ArrayList<String>();
    replace.add(cut(f));
    replace.add(t);
    return Messages.getString(DuMP3.class, 56, replace);
  }

  {
    // Register as a resource user - SWTResourceManager will
    // handle the obtaining and disposing of resources
    SWTResourceManager.registerResourceUser(this);
  }

  /**
   * <code>btnAdd1</code> DuMP3 -
   */
  Button btnAdd1;
  /**
   * <code>btnAdd2</code> DuMP3 -
   */
  Button btnAdd2;
  /**
   * <code>btnBack</code> DuMP3 -
   */
  Button btnBack;
  /**
   * <code>btnNext</code> DuMP3 -
   */
  Button btnNext;
  /**
   * <code>btnRem1</code> DuMP3 -
   */
  Button btnRem1;
  /**
   * <code>btnRem2</code> DuMP3 -
   */
  Button btnRem2;
  /**
   * <code>buttonBar</code> DuMP3 -
   */
  Composite buttonBar;
  /**
   * <code>composite1</code> DuMP3 -
   */
  Composite composite1;
  /**
   * <code>composite2</code> DuMP3 -
   */
  Composite composite2;
  /**
   * <code>composite3</code> DuMP3 -
   */
  Composite composite3;
  /**
   * <code>composite5</code> DuMP3 -
   */
  Composite composite5;
  /**
   * <code>composite5bottomImage</code> DuMP3 -
   */
  Composite composite5bottomImage;
  /**
   * <code>composite5right</code> DuMP3 -
   */
  Composite composite5right;
  /**
   * <code>composite5topImage</code> DuMP3 -
   */
  Composite composite5topImage;
  /**
   * <code>composite5topText</code> DuMP3 -
   */
  Composite composite5topText;
  /**
   * <code>cTabItem1</code> DuMP3 -
   */
  CTabItem cTabItem1;
  /**
   * <code>cTabItem2</code> DuMP3 -
   */
  CTabItem cTabItem2;
  /**
   * <code>cTabItem3</code> DuMP3 -
   */
  CTabItem cTabItem3;
  /**
   * <code>cTabItem4</code> DuMP3 -
   */
  CTabItem cTabItem4;
  /**
   * <code>cTabItem5</code> DuMP3 -
   */
  CTabItem cTabItem5;
  /**
   * <code>cTabItem6</code> DuMP3 -
   */
  CTabItem cTabItem6;
  /**
   * <code>cTabItem7</code> DuMP3 -
   */
  CTabItem cTabItem7;
  /**
   * <code>ctfMainTab</code> DuMP3 -
   */
  CTabFolder ctfMainTab;
  /**
   * <code>duplicateList</code> DuMP3 - list of duplicates found
   */
  final List<FingerprintFile> duplicateList = Collections.synchronizedList(new ArrayList<FingerprintFile>());
  /**
   * <code>fileList</code> DuMP3 - file list
   */
  private final List<File> fileList = Collections.synchronizedList(new ArrayList<File>());
  /**
   * <code>lblDatabase</code> DuMP3 - 
   */
  private Label lblDatabase;
  /**
   * <code>lblStatus</code> DuMP3 -
   */
  Label lblStatus;
  /**
   * <code>lnkVersion</code> DuMP3 - version display bottom right
   */
  Link lnkVersion;
  /**
   * <code>prevLeft</code> DuMP3 -
   */
  private FingerprintFile prevLeft = null;
  /**
   * <code>prevRight</code> DuMP3 -
   */
  private FingerprintFile prevRight = null;
  /**
   * <code>prints</code> DuMP3 - fingerprint list
   */
  private final Set<Class< ? extends AbstractFingerprint>> prints =
    Collections.synchronizedSet(new HashSet<Class< ? extends AbstractFingerprint>>());
  /**
   * <code>progress</code> DuMP3 - finer control over the progress bar
   */
  double progress = 0.0;
  /**
   * <code>progressBar</code> DuMP3 -
   */
  ProgressBar progressBar;
  /**
   * <code>readers</code> DuMP3 -
   */
  private final List<DirectoryReader> readers = new ArrayList<DirectoryReader>();
  /**
   * <code>sash5</code> DuMP3 -
   */
  Sash sash5;
  /**
   * <code>sash5right</code> DuMP3 -
   */
  Sash sash5right;
  /**
   * <code>selectedTypeList</code> DuMP3 - selected file types
   */
  private final List<ExtensionCount> selectedTypeList = Collections.synchronizedList(new ArrayList<ExtensionCount>());
  /**
   * <code>startSpeed</code> DuMP3 - date/time the comparison started - for speed indicator
   */
  Date startSpeed;
  /**
   * <code>tableViewerFingerprintConfig</code> DuMP3 -
   */
  TableViewer tableViewerFingerprintConfig;
  /**
   * <code>tableViewerFingerprintExtensions</code> DuMP3 -
   */
  TableViewer tableViewerFingerprintExtensions;
  /**
   * <code>tableViewerFingerprintTypes</code> DuMP3 -
   */
  TableViewer tableViewerFingerprintTypes;
  /**
   * <code>tableViewerFoundExtensions</code> DuMP3 -
   */
  TableViewer tableViewerFoundExtensions;
  /**
   * <code>tableViewerSelectedExtensions</code> DuMP3 -
   */
  TableViewer tableViewerSelectedExtensions;
  /**
   * <code>toolBarLeft</code> DuMP3 -
   */
  ToolBar toolBarLeft;
  /**
   * <code>toolBarRight</code> DuMP3 -
   */
  ToolBar toolBarRight;
  /**
   * <code>toolItemLDelete</code> DuMP3 -
   */
  ToolItem toolItemLDelete;
  /**
   * <code>toolItemLMove</code> DuMP3 -
   */
  ToolItem toolItemLMove;
  /**
   * <code>toolItemLTrash</code> DuMP3 -
   */
  ToolItem toolItemLTrash;
  /**
   * <code>toolItemRDelete</code> DuMP3 -
   */
  ToolItem toolItemRDelete;
  /**
   * <code>toolItemRMove</code> DuMP3 -
   */
  ToolItem toolItemRMove;
  /**
   * <code>toolItemRTrash</code> DuMP3 -
   */
  ToolItem toolItemRTrash;
  /**
   * <code>treeViewerCompareResults</code> DuMP3 -
   */
  TreeViewer treeViewerCompareResults;
  /**
   * <code>treeViewerMyComputer</code> DuMP3 -
   */
  TreeViewer treeViewerMyComputer;
  /**
   * <code>treeViewerSelectedFiles</code> DuMP3 -
   */
  TreeViewer treeViewerSelectedFiles;
  /**
   * <code>typeList</code> DuMP3 - displayed file type list
   */
  private final List<ExtensionCount> typeList = Collections.synchronizedList(new ArrayList<ExtensionCount>());
  /**
   * <code>typeMap</code> DuMP3 - temporary file type list while collecting
   */
  private final Map<String, ExtensionCount> typeMap = Collections.synchronizedMap(new HashMap<String, ExtensionCount>());
  /**
   * <code>typeThreadsStarted</code> DuMP3 -
   */
  private int typeThreadsStarted = 0;

  /**
   * @param parent
   * @param style
   */
  public DuMP3(final Composite parent, final int style) {
    super(parent, style);
    initGUI();
  }

  /**
   * This constructor is used by the getGUIBuilderInstance method to provide an instance of this class which has not had it's GUI elements initialized (ie,
   * initGUI is not called in this constructor).
   * 
   * @param parent
   * @param style
   * @param initGUI
   */
  public DuMP3(final org.eclipse.swt.widgets.Composite parent, final int style, final Boolean initGUI) {
    super(parent, style);
  }

  /**
   * @param evt
   */
  @SuppressWarnings("unchecked")
  void btnAdd1WidgetSelected(final SelectionEvent evt) {
    if (!treeViewerMyComputer.getSelection().isEmpty()) {
      final IStructuredSelection selection = (IStructuredSelection)treeViewerMyComputer.getSelection();
      final Iterator<File> it = selection.iterator();
      while (it.hasNext()) {
        final File f = it.next();
        boolean found = false;
        for (final File lFile : fileList) {
          // TODO fix this check?
          if (f.equals(lFile)
            || ((lFile.getPath().length() < f.getPath().length()) && lFile.getPath().equals(
              f.getPath().substring(0, lFile.getPath().length())))) {
            found = true;
            break;
          }
        }
        if (!found) {
          fileList.add(f);
          treeViewerSelectedFiles.refresh();
          if (f.isDirectory()) {
            lblStatus.setText(Messages.getString(DuMP3.class, 10));
          } else {
            lblStatus.setText(Messages.getString(DuMP3.class, 11));
          }
        } else {
          if (f.isDirectory()) {
            lblStatus.setText(Messages.getString(DuMP3.class, 12));
          } else {
            lblStatus.setText(Messages.getString(DuMP3.class, 13));
          }
          lblStatus.setToolTipText(Messages.getString(DuMP3.class, 14));
        }
      }
      clearTab(2);
      clearTab(3);
      clearTab(4);
      clearTab(5);
      clearTab(6);
      ctfMainTab.setSelection(cTabItem1);
      btnBack.setEnabled(false);
      btnNext.setEnabled(!fileList.isEmpty());
    } else {
      lblStatus.setText(Messages.getString(DuMP3.class, 15));
      lblStatus.setToolTipText(Messages.getString(DuMP3.class, 16));
    }
    btnNext.setEnabled(!fileList.isEmpty());
  }

  /**
   * @param evt
   */
  @SuppressWarnings("unchecked")
  void btnAdd2WidgetSelected(final SelectionEvent evt) {
    if (!tableViewerFoundExtensions.getSelection().isEmpty()) {
      final IStructuredSelection selection = (IStructuredSelection)tableViewerFoundExtensions.getSelection();
      selectedTypeList.addAll(selection.toList());
      typeList.removeAll(selection.toList());
      tableViewerSelectedExtensions.refresh();
      tableViewerFoundExtensions.refresh();
      lblStatus.setText(Messages.getString(DuMP3.class, 17));
      clearTab(3);
      clearTab(4);
      clearTab(5);
      clearTab(6);
      ctfMainTab.setSelection(cTabItem2);
      btnBack.setEnabled(true);
      btnNext.setEnabled(!selectedTypeList.isEmpty());
    } else {
      lblStatus.setText(Messages.getString(DuMP3.class, 18));
      lblStatus.setToolTipText(Messages.getString(DuMP3.class, 19));
    }
    btnNext.setEnabled(!selectedTypeList.isEmpty());
  }

  /**
   * @param evt
   */
  void btnBackWidgetSelected(final SelectionEvent evt) {
    if (ctfMainTab.getSelection() == cTabItem2) {
      ctfMainTab.setSelection(cTabItem1);
      btnBack.setEnabled(false);
      btnNext.setEnabled(!fileList.isEmpty());
    } else if (ctfMainTab.getSelection() == cTabItem3) {
      ctfMainTab.setSelection(cTabItem2);
      btnBack.setEnabled(true);
      btnNext.setEnabled(!selectedTypeList.isEmpty());
    } else if (ctfMainTab.getSelection() == cTabItem4) {
      ctfMainTab.setSelection(cTabItem3);
      btnBack.setEnabled(true);
      btnNext.setEnabled(true);
    } else if (ctfMainTab.getSelection() == cTabItem5) {
      // is now a stop button
      final Comparer compare = Comparer.getInstance();
      if (compare.isRunning()) {
        lblStatus.setText(Messages.getString(DuMP3.class, 82));
        btnBack.setEnabled(false);
        compare.stop();
        return;
      }
      ctfMainTab.setSelection(cTabItem3);
      btnBack.setEnabled(true);
      btnBack.setText(Messages.getString(DuMP3.class, 35));
      btnNext.setEnabled(true);
    } else if (ctfMainTab.getSelection() == cTabItem6) {
      ctfMainTab.setSelection(cTabItem5);
      btnBack.setEnabled(true);
      // TODO - change once cleanup screen is done
      btnNext.setEnabled(false);
    } else if (ctfMainTab.getSelection() == cTabItem7) {
      // actually the OK button
      ctfMainTab.setSelection(cTabItem1);
      btnBack.setText(Messages.getString(DuMP3.class, 35));
      btnNext.setText(Messages.getString(DuMP3.class, 36));
    }
  }

  /**
   * @param evt
   */
  void btnNextWidgetSelected(final SelectionEvent evt) {
    btnNext.setEnabled(false);
    if (ctfMainTab.getSelection() == cTabItem1) {
      lblStatus.setText(Messages.getString(DuMP3.class, 20));
      final Iterator<File> it = fileList.iterator();
      clearTab(2);
      clearTab(3);
      clearTab(4);
      clearTab(5);
      clearTab(6);
      while (it.hasNext()) {
        File f = it.next();
        String wc = Strings.STAR;
        if (f.isFile()) {
          wc = f.getName();
          f = f.getParentFile();
        }
        final DirectoryInfo df = new DirectoryInfo(f.getPath());
        final DirectoryReader dr;
        try {
          dr = new DirectoryReader(wc, df);
          readers.add(dr);
          dr.addObserver(this);
          dr.start();
          typeThreadsStarted++;
        } catch (final FileNotFoundException fnf) {
          log.error(Debug.getString(DuMP3.class, 21), fnf);
        }
      }
    } else if (ctfMainTab.getSelection() == cTabItem2) {
      lblStatus.setText(Messages.getString(DuMP3.class, 22));
      prints.clear();
      clearTab(3);
      clearTab(4);
      clearTab(5);
      clearTab(6);
      final Iterator<ExtensionCount> it = selectedTypeList.iterator();
      while (it.hasNext()) {
        prints.addAll(FingerprintFactory.getFingerprintTypes(it.next().toString()));
      }
      ctfMainTab.setSelection(cTabItem3);
      btnNext.setEnabled(true);
      btnBack.setEnabled(true);
      progressBar.setSelection(0);
      progress = 0.0;
      lblStatus.setText(Messages.getString(DuMP3.class, 23));
      tableViewerFingerprintTypes.refresh();
    } else if (ctfMainTab.getSelection() == cTabItem3) {
      final Comparer compare = Comparer.getInstance();
      if (compare.isRunning()) {
        lblStatus.setText(Messages.getString(DuMP3.class, 82));
        compare.clear();
        return;
      }
      ctfMainTab.setSelection(cTabItem5);
      clearTab(4);
      clearTab(5);
      clearTab(6);
      // TODO - change once auto rules screen is done
      btnNext.setEnabled(false);
      btnBack.setEnabled(true);
      // back is now a stop button
      btnBack.setText(Messages.getString(DuMP3.class, 81));
      final StringBuffer wc = new StringBuffer();
      progress = 0.0;
      int count = 0;
      for (final ExtensionCount lExt : selectedTypeList) {
        wc.append(Chars.OPN_BRACKET).append(WildcardFilter.createRegEx(lExt.toString())).append(Chars.CLS_BRACKET).append(Chars.PIPE);
        count += lExt.getCount();
      }
      progressBar.setMaximum(count);
      final List<Integer> replace = new ArrayList<Integer>();
      replace.add(new Integer(count));
      lblStatus.setText(Messages.getString(DuMP3.class, 24, replace));
      if ((wc.length() > 0) && (wc.charAt(wc.length() - 1) == Chars.PIPE)) {
        wc.setLength(wc.length() - 1);
      }
      compare.deleteObserver(this);
      compare.addObserver(this);
      compare.clear();
      compare.start();
      for (final DirectoryReader lDr : readers) {
        try {
          lDr.setWildcard(wc.toString(), true);
          lDr.deleteObserver(this);
          compare.addReader(lDr);
          lDr.start();
        } catch (final FileNotFoundException fnf) {
          log.error(Debug.getString(DuMP3.class, 21), fnf);
        }
      }
    } else if (ctfMainTab.getSelection() == cTabItem4) {
      ctfMainTab.setSelection(cTabItem5);
    } else if (ctfMainTab.getSelection() == cTabItem5) {
      ctfMainTab.setSelection(cTabItem6);
    } else if (ctfMainTab.getSelection() == cTabItem7) {
      // actually the Cancel button
      ctfMainTab.setSelection(cTabItem1);
      btnBack.setText(Messages.getString(DuMP3.class, 35));
      btnNext.setText(Messages.getString(DuMP3.class, 36));
    }
  }

  /**
   * @param evt
   */
  @SuppressWarnings("unchecked")
  void btnRem1WidgetSelected(final SelectionEvent evt) {
    if (!treeViewerSelectedFiles.getSelection().isEmpty()) {
      final IStructuredSelection selection = (IStructuredSelection)treeViewerSelectedFiles.getSelection();
      final Iterator<File> sel = selection.iterator();
      while (sel.hasNext()) {
        final File f = sel.next();
        final Iterator<File> it = fileList.iterator();
        boolean found = false;
        while (it.hasNext()) {
          if (f.equals(it.next())) {
            found = true;
            break;
          }
        }
        if (found) {
          fileList.remove(f);
          treeViewerSelectedFiles.refresh();
          if (f.isDirectory()) {
            lblStatus.setText(Messages.getString(DuMP3.class, 25));
          } else {
            lblStatus.setText(Messages.getString(DuMP3.class, 26));
          }
        } else {
          if (f.isDirectory()) {
            lblStatus.setText(Messages.getString(DuMP3.class, 27));
          } else {
            lblStatus.setText(Messages.getString(DuMP3.class, 28));
          }
          lblStatus.setToolTipText(Messages.getString(DuMP3.class, 29));
        }
      }
      clearTab(2);
      clearTab(3);
      clearTab(4);
      clearTab(5);
      clearTab(6);
      ctfMainTab.setSelection(cTabItem1);
      btnBack.setEnabled(false);
      btnNext.setEnabled(!fileList.isEmpty());
    } else {
      lblStatus.setText(Messages.getString(DuMP3.class, 30));
      lblStatus.setToolTipText(Messages.getString(DuMP3.class, 31));
    }
    btnNext.setEnabled(!fileList.isEmpty());
  }

  /**
   * @param evt
   */
  @SuppressWarnings("unchecked")
  void btnRem2WidgetSelected(final SelectionEvent evt) {
    if (!tableViewerSelectedExtensions.getSelection().isEmpty()) {
      final IStructuredSelection selection = (IStructuredSelection)tableViewerSelectedExtensions.getSelection();
      selectedTypeList.removeAll(selection.toList());
      typeList.addAll(selection.toList());
      tableViewerFoundExtensions.refresh();
      tableViewerSelectedExtensions.refresh();
      lblStatus.setText(Messages.getString(DuMP3.class, 32));
      clearTab(3);
      clearTab(4);
      clearTab(5);
      clearTab(6);
      ctfMainTab.setSelection(cTabItem2);
      btnBack.setEnabled(true);
      btnNext.setEnabled(!selectedTypeList.isEmpty());
    } else {
      lblStatus.setText(Messages.getString(DuMP3.class, 33));
      lblStatus.setToolTipText(Messages.getString(DuMP3.class, 34));
    }
    btnNext.setEnabled(!selectedTypeList.isEmpty());
  }

  /**
   * This method clears the selected items on the specified tab panel.
   * 
   * @param pTab
   */
  private void clearTab(final int pTab) {
    switch (pTab) {
      default:
      case 1:
        // clear directory selection tab
        progress = 0.0;
        progressBar.setMaximum(100);
        fileList.clear();
        getTreeViewerSelectedFiles().refresh();
        break;
      case 2:
        // clear file extension selection tab
        for (DirectoryReader r : readers) {
          r.stop();
        }
        progress = 0.0;
        progressBar.setMaximum(100);
        readers.clear();
        typeMap.clear();
        typeList.clear();
        selectedTypeList.clear();
        getTableViewerFoundExtensions().refresh();
        getTableViewerSelectedExtensions().refresh();
        break;
      case 3:
        // clear configuration tab
        prints.clear();
        getTableViewerFingerprintTypes().refresh();
        getTableViewerFingerprintConfig().setInput(null);
        getTableViewerFingerprintConfig().refresh();
        break;
      case 4:
        // clear automatic rules tab
        break;
      case 5:
        // clear duplicate display tab
        duplicateList.clear();
        getTreeViewerCompareResults().refresh();
        Comparer.getInstance().clear();
        break;
      case 6:
        // clear cleanup tab
        break;
    }
  }

  /**
   * @param evt
   */
  void ctfMainTabWidgetSelected(final SelectionEvent evt) {
    if (evt.getSource() instanceof CTabFolder) {
      final CTabFolder tf = (CTabFolder)evt.getSource();
      final CTabItem ti = tf.getSelection();
      btnBack.setText(Messages.getString(DuMP3.class, 35));
      btnNext.setText(Messages.getString(DuMP3.class, 36));
      if (ti == cTabItem1) {
        btnBack.setEnabled(false);
        btnNext.setEnabled(!fileList.isEmpty());
      } else if (ti == cTabItem2) {
        btnBack.setEnabled(true);
        btnNext.setEnabled(!selectedTypeList.isEmpty());
      } else if (ti == cTabItem3) {
        btnBack.setEnabled(true);
        btnNext.setEnabled(true);
      } else if (ti == cTabItem4) {
        btnBack.setEnabled(true);
        btnNext.setEnabled(true);
      } else if (ti == cTabItem5) {
        btnBack.setEnabled(true);
        // TODO - fix once cleanup screen is done
        btnNext.setEnabled(false);
      } else if (ti == cTabItem6) {
        btnBack.setEnabled(true);
        btnNext.setEnabled(false);
      } else if (ti == cTabItem7) {
        btnBack.setEnabled(true);
        btnNext.setEnabled(true);
        btnBack.setText(Messages.getString(DuMP3.class, 79));
        btnNext.setText(Messages.getString(DuMP3.class, 80));
      } else {
        btnBack.setEnabled(false);
        btnNext.setEnabled(false);
      }
    }
  }

  /**
   * This method displays the compare window
   * 
   * @param left
   * @param right
   */
  private void displayCompare(final FingerprintFile left, final FingerprintFile right) {
    if (log.isDebugEnabled()) {
      final List<FingerprintFile> replace = new ArrayList<FingerprintFile>();
      replace.add(left);
      log.debug(Debug.getString(DuMP3.class, 75, replace));
      replace.clear();
      replace.add(right);
      log.debug(Debug.getString(DuMP3.class, 76, replace));
    }
    display.asyncExec(new Runnable() {
      public void run() {
        synchronized (toolItemLDelete) {
          if (!toolItemLDelete.isDisposed()) {
            toolItemLDelete.setData(left);
          }
          if (!toolItemRDelete.isDisposed()) {
            toolItemRDelete.setData(right);
          }
          if (!toolItemLTrash.isDisposed()) {
            toolItemLTrash.setData(left);
          }
          if (!toolItemRTrash.isDisposed()) {
            toolItemRTrash.setData(right);
          }
          if (!toolItemLMove.isDisposed()) {
            toolItemLMove.setData(left);
          }
          if (!toolItemRMove.isDisposed()) {
            toolItemRMove.setData(right);
          }
        }
        // hide all composites
        hideDisplays();
        // info display
        ((DoubleInfo)getComposite5bottomInfo()).display(left, right);
        // top display
        final List<Class< ? extends AbstractFingerprint>> s = FingerprintFactory.getFingerprintTypes(left.getExtension());
        final Iterator<Class< ? extends AbstractFingerprint>> it = s.iterator();
        int type = -1;
        while (it.hasNext()) {
          final Class< ? > cls = it.next();
          if (cls.getName().indexOf(ColorFingerprint.class.getSimpleName()) >= 0) {
            getComposite5topImage().setVisible(true);
            ((DoubleDisplay)getComposite5topImage()).display(left, right);
            type = 1;
          }
          if (cls.getName().indexOf(FdmfFingerprint.class.getSimpleName()) >= 0) {
            // getComposite5topAudio().setVisible(true);
            type = 2;
          }
          if ((cls.getName().indexOf(SifFingerprint.class.getSimpleName()) >= 0)
            || (cls.getName().indexOf(SubstringFingerprint.class.getSimpleName()) >= 0)) {
            getComposite5topText().setVisible(true);
            ((DoubleDisplay)getComposite5topText()).display(left, right);
            type = 3;
          }
        }
        if (type < 0) {
          // getComposite5topBinary().setVisible(true);
        }
      }
    });
  }

  /**
   * @return Button
   */
  public Button getBtnAdd1() {
    if (btnAdd1 == null) {
      btnAdd1 = new Button(composite1, SWT.PUSH | SWT.CENTER);
      btnAdd1.setText(Strings.GT);
      final FormData button2LData = new FormData();
      button2LData.width = 71;
      button2LData.height = 27;
      button2LData.left = new FormAttachment(451, 1000, 0);
      button2LData.right = new FormAttachment(540, 1000, 0);
      button2LData.top = new FormAttachment(39, 1000, 0);
      button2LData.bottom = new FormAttachment(92, 1000, 0);
      btnAdd1.setLayoutData(button2LData);
      btnAdd1.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnAdd1WidgetSelected(evt);
        }
      });
    }
    return btnAdd1;
  }

  /**
   * @return Button
   */
  public Button getBtnAdd2() {
    if (btnAdd2 == null) {
      btnAdd2 = new Button(composite2, SWT.PUSH | SWT.CENTER);
      btnAdd2.setText(Strings.GT);
      final FormData button1LData2 = new FormData();
      button1LData2.width = 71;
      button1LData2.height = 27;
      button1LData2.left = new FormAttachment(451, 1000, 0);
      button1LData2.right = new FormAttachment(540, 1000, 0);
      button1LData2.top = new FormAttachment(39, 1000, 0);
      button1LData2.bottom = new FormAttachment(92, 1000, 0);
      btnAdd2.setLayoutData(button1LData2);
      btnAdd2.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnAdd2WidgetSelected(evt);
        }
      });
    }
    return btnAdd2;
  }

  /**
   * @return Button
   */
  public Button getBtnBack() {
    if (btnBack == null) {
      btnBack = new Button(buttonBar, SWT.PUSH | SWT.CENTER);
      listener.addMapping(SWT.NONE, 27, btnBack);
      final FormData btnNextLData = new FormData();
      btnNextLData.width = 70;
      btnNextLData.height = 28;
      btnNextLData.left = new FormAttachment(559, 1000, 0);
      btnNextLData.right = new FormAttachment(764, 1000, 0);
      btnNextLData.top = new FormAttachment(0, 1000, 1);
      btnNextLData.bottom = new FormAttachment(1000, 1000, -1);
      btnBack.setLayoutData(btnNextLData);
      btnBack.setText(Messages.getString(DuMP3.class, 35));
      btnBack.setEnabled(false);
      btnBack.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnBackWidgetSelected(evt);
        }
      });
    }
    return btnBack;
  }

  /**
   * @return Button
   */
  public Button getBtnNext() {
    if (btnNext == null) {
      btnNext = new Button(buttonBar, SWT.PUSH | SWT.CENTER);
      btnNext.setText(Messages.getString(DuMP3.class, 36));
      final FormData button1LData = new FormData();
      button1LData.width = 63;
      button1LData.height = 28;
      button1LData.left = new FormAttachment(785, 1000, 0);
      button1LData.right = new FormAttachment(990, 1000, 0);
      button1LData.top = new FormAttachment(0, 1000, 1);
      button1LData.bottom = new FormAttachment(1000, 1000, -1);
      btnNext.setLayoutData(button1LData);
      btnNext.setEnabled(false);
      btnNext.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnNextWidgetSelected(evt);
        }
      });
    }
    return btnNext;
  }

  /**
   * @return Button
   */
  public Button getBtnRem1() {
    if (btnRem1 == null) {
      btnRem1 = new Button(composite1, SWT.PUSH | SWT.CENTER);
      btnRem1.setText(Strings.LT);
      final FormData button1LData1 = new FormData();
      button1LData1.width = 71;
      button1LData1.height = 25;
      button1LData1.left = new FormAttachment(451, 1000, 0);
      button1LData1.right = new FormAttachment(540, 1000, 0);
      button1LData1.top = new FormAttachment(108, 1000, 0);
      button1LData1.bottom = new FormAttachment(156, 1000, 0);
      btnRem1.setLayoutData(button1LData1);
      btnRem1.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnRem1WidgetSelected(evt);
        }
      });
    }
    return btnRem1;
  }

  /**
   * @return Button
   */
  public Button getBtnRem2() {
    if (btnRem2 == null) {
      btnRem2 = new Button(composite2, SWT.PUSH | SWT.CENTER);
      btnRem2.setText(Strings.LT);
      final FormData button2LData1 = new FormData();
      button2LData1.width = 71;
      button2LData1.height = 25;
      button2LData1.left = new FormAttachment(451, 1000, 0);
      button2LData1.right = new FormAttachment(540, 1000, 0);
      button2LData1.top = new FormAttachment(108, 1000, 0);
      button2LData1.bottom = new FormAttachment(156, 1000, 0);
      btnRem2.setLayoutData(button2LData1);
      btnRem2.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          btnRem2WidgetSelected(evt);
        }
      });
    }
    return btnRem2;
  }

  /**
   * @return Composite
   */
  public Composite getButtonBar() {
    if (buttonBar == null) {
      buttonBar = new Composite(this, SWT.NONE);
      final FormLayout buttonBarLayout = new FormLayout();
      buttonBar.setLayout(buttonBarLayout);
      final FormData buttonBarLData = new FormData();
      buttonBarLData.width = 800;
      buttonBarLData.height = 35;
      buttonBarLData.left = new FormAttachment(0, 1000, 0);
      buttonBarLData.right = new FormAttachment(1000, 1000, 0);
      buttonBarLData.bottom = new FormAttachment(1000, 1000, -26);
      buttonBar.setLayoutData(buttonBarLData);
      buttonBar.setBackground(null);
      getProgressBar();
      getLblDatabase();
      getBtnBack();
      getBtnNext();
    }
    return buttonBar;
  }

  /**
   * @return Composite
   */
  public Composite getComposite1() {
    if (composite1 == null) {
      composite1 = new Composite(ctfMainTab, SWT.NONE);
      cTabItem1.setControl(composite1);
      final FormLayout composite1Layout = new FormLayout();
      composite1.setLayout(composite1Layout);
      getTreeViewerMyComputer();
      getTreeViewerSelectedFiles();
      getBtnAdd1();
      getBtnRem1();
    }
    return composite1;
  }

  /**
   * @return Composite
   */
  public Composite getComposite2() {
    if (composite2 == null) {
      composite2 = new Composite(ctfMainTab, SWT.NONE);
      final FormLayout composite2Layout = new FormLayout();
      composite2.setLayout(composite2Layout);
      cTabItem2.setControl(composite2);
      getTableViewerFoundExtensions();
      getTableViewerSelectedExtensions();
      getBtnAdd2();
      getBtnRem2();
    }
    return composite2;
  }

  /**
   * @return Composite
   */
  public Composite getComposite3() {
    if (composite3 == null) {
      composite3 = new Composite(ctfMainTab, SWT.NONE);
      final FormLayout composite3Layout = new FormLayout();
      composite3.setLayout(composite3Layout);
      cTabItem3.setControl(composite3);
      getTableViewerFingerprintTypes();
      getTableViewerFingerprintConfig();
      getTableViewerFingerprintExtensions();
    }
    return composite3;
  }

  /**
   * This method ...
   * 
   * @return Composite
   */
  private Composite getComposite5() {
    if (composite5 == null) {
      composite5 = new Composite(ctfMainTab, SWT.NONE);
      final FormLayout composite5Layout = new FormLayout();
      composite5.setLayout(composite5Layout);
      cTabItem5.setControl(composite5);
      final FormData sashData = new FormData();
      final int limit = 20, percent = 33;
      if (horizontalLayout) {
        sash5 = new Sash(composite5, SWT.HORIZONTAL);
        sashData.top = new FormAttachment(percent, 0);
        sashData.left = new FormAttachment(0, 0);
        sashData.right = new FormAttachment(100, 0);
        sash5.addListener(SWT.Selection, new Listener() {
          public void handleEvent(final Event e) {
            final Rectangle sashRect = sash5.getBounds();
            final Rectangle shellRect = composite5.getClientArea();
            final int bottom = shellRect.height - sashRect.height - limit;
            e.y = Math.max(Math.min(e.y, bottom), limit);
            if (e.y != sashRect.y) {
              sashData.top = new FormAttachment(0, e.y);
              composite5.layout();
            }
          }
        });
      } else {
        sash5 = new Sash(composite5, SWT.VERTICAL);
        sashData.left = new FormAttachment(percent, 0);
        sashData.top = new FormAttachment(0, 0);
        sashData.bottom = new FormAttachment(100, 0);
        sash5.addListener(SWT.Selection, new Listener() {
          public void handleEvent(final Event e) {
            final Rectangle sashRect = sash5.getBounds();
            final Rectangle shellRect = composite5.getClientArea();
            final int right = shellRect.width - sashRect.width - limit;
            e.x = Math.max(Math.min(e.x, right), limit);
            if (e.x != sashRect.x) {
              sashData.left = new FormAttachment(0, e.x);
              composite5.layout();
            }
          }
        });
      }
      sash5.setLayoutData(sashData);
      getTreeViewerCompareResults();
      getComposite5right();
    }
    return composite5;
  }

  /**
   * @return composite5bottomImage
   */
  public Composite getComposite5bottomInfo() {
    if (composite5bottomImage == null) {
      composite5bottomImage = new DoubleInfo(composite5right, SWT.NONE);
      final FormLayout composite5bottomImageLayout = new FormLayout();
      composite5bottomImage.setLayout(composite5bottomImageLayout);
      final FormData composite5bottomImageLData = new FormData();
      composite5bottomImageLData.width = 63;
      composite5bottomImageLData.height = 63;
      composite5bottomImageLData.left = new FormAttachment(0, 1000, 0);
      composite5bottomImageLData.top = new FormAttachment(sash5right, 31);
      composite5bottomImageLData.right = new FormAttachment(1000, 1000, 0);
      composite5bottomImageLData.bottom = new FormAttachment(1000, 1000, 0);
      composite5bottomImage.setLayoutData(composite5bottomImageLData);
    }
    return composite5bottomImage;
  }

  /**
   * @return composite5right
   */
  public Composite getComposite5right() {
    if (composite5right == null) {
      composite5right = new Composite(composite5, SWT.NONE);
      final FormLayout composite5rightLayout = new FormLayout();
      composite5right.setLayout(composite5rightLayout);
      final FormData composite5rightLData = new FormData();
      composite5rightLData.width = 63;
      composite5rightLData.height = 63;
      if (horizontalLayout) {
        composite5rightLData.left = new FormAttachment(0, 1000, 3);
        composite5rightLData.top = new FormAttachment(sash5, 0);
      } else {
        composite5rightLData.left = new FormAttachment(sash5, 0);
        composite5rightLData.top = new FormAttachment(0, 1000, 6);
      }
      composite5rightLData.right = new FormAttachment(1000, 1000, -6);
      composite5rightLData.bottom = new FormAttachment(994, 1000, 0);
      composite5right.setLayoutData(composite5rightLData);
      sash5right = new Sash(composite5right, SWT.HORIZONTAL);
      final int limit = 26, percent = 65;
      final FormData sashData = new FormData();
      sashData.left = new FormAttachment(0, 0);
      sashData.top = new FormAttachment(percent, 0);
      sashData.right = new FormAttachment(100, 0);
      sash5right.setLayoutData(sashData);
      sash5right.addListener(SWT.Selection, new Listener() {
        public void handleEvent(final Event e) {
          final Rectangle sashRect = sash5right.getBounds();
          final Rectangle shellRect = composite5right.getClientArea();
          final int bottom = shellRect.height - sashRect.height - limit;
          e.y = Math.max(Math.min(e.y, bottom), limit);
          if (e.y != sashRect.y) {
            sashData.top = new FormAttachment(0, e.y);
            composite5right.layout();
          }
        }
      });
      getComposite5topImage();
      getComposite5topText();
      getToolBarLeft();
      getToolBarRight();
      getComposite5bottomInfo();
    }
    return composite5right;
  }

  /**
   * @return composite5topImage
   */
  public Composite getComposite5topImage() {
    if (composite5topImage == null) {
      composite5topImage = DoubleDisplayFactory.getInstance().makeDoubleDisplay(IMAGE, composite5right, SWT.NONE);
      final FormLayout composite5topImageLayout = new FormLayout();
      composite5topImage.setLayout(composite5topImageLayout);
      final FormData composite5topImageLData = new FormData();
      composite5topImageLData.width = 63;
      composite5topImageLData.height = 63;
      composite5topImageLData.left = new FormAttachment(0, 1000, 0);
      composite5topImageLData.top = new FormAttachment(0, 1000, 0);
      composite5topImageLData.right = new FormAttachment(1000, 1000, 0);
      composite5topImageLData.bottom = new FormAttachment(sash5right, 0);
      composite5topImage.setLayoutData(composite5topImageLData);
    }
    return composite5topImage;
  }

  /**
   * @return composite5topText
   */
  public Composite getComposite5topText() {
    if (composite5topText == null) {
      composite5topText = DoubleDisplayFactory.getInstance().makeDoubleDisplay(TEXT, composite5right, SWT.NONE);
      final FormLayout composite5topTextLayout = new FormLayout();
      composite5topText.setLayout(composite5topTextLayout);
      final FormData composite5topTextLData = new FormData();
      composite5topTextLData.width = 63;
      composite5topTextLData.height = 63;
      composite5topTextLData.left = new FormAttachment(0, 1000, 0);
      composite5topTextLData.top = new FormAttachment(0, 1000, 0);
      composite5topTextLData.right = new FormAttachment(1000, 1000, 0);
      composite5topTextLData.bottom = new FormAttachment(sash5right, 0);
      composite5topText.setLayoutData(composite5topTextLData);
    }
    return composite5topText;
  }

  /**
   * This method creates and returns the database label.
   * @return Label
   */
  public Label getLblDatabase() {
    if (lblDatabase == null) {
      lblDatabase = new Label(buttonBar, SWT.WRAP);
      FormData labelDatabaseLData = new FormData();
      labelDatabaseLData.width = 46;
      labelDatabaseLData.height = 13;
      labelDatabaseLData.left =  new FormAttachment(434, 1000, 5);
      labelDatabaseLData.right =  new FormAttachment(559, 1000, -5);
      labelDatabaseLData.top = new FormAttachment(0, 1000, 1);
      labelDatabaseLData.bottom = new FormAttachment(1000, 1000, -1);
      lblDatabase.setLayoutData(labelDatabaseLData);
      final List<String> replace = new ArrayList<String>();
      replace.add(DatabaseFactory.getDatabase().getName());
      replace.add(DatabaseFactory.getDatabase().getVersion());
      lblDatabase.setText(Messages.getString(DuMP3.class, 95, replace));
      lblDatabase.setDragDetect(false);
    }
    return lblDatabase;
  }

  /**
   * @return Label
   */
  public Label getLblStatus() {
    if (lblStatus == null) {
      lblStatus = new Label(this, SWT.NONE);
      lblStatus.setText(Messages.getString(DuMP3.class, 38));
      lblStatus.setBackground(null);
      final FormData lblStatusLData = new FormData();
      lblStatusLData.width = 553;
      lblStatusLData.height = 21;
      lblStatusLData.left = new FormAttachment(0, 1000, 5);
      lblStatusLData.bottom = new FormAttachment(1000, 1000, -2);
      lblStatusLData.top = new FormAttachment(1000, 1000, -23);
      lblStatusLData.right = new FormAttachment(700, 1000, 0);
      lblStatus.setLayoutData(lblStatusLData);
    }
    return lblStatus;
  }

  /**
   * @return Label
   */
  public Link getLnkVersion() {
    if (lnkVersion == null) {
      lnkVersion = new Link(this, SWT.RIGHT);
      lnkVersion.setBackground(null);
      final List<String> replace = new ArrayList<String>();
      final int msg;
      if (SplashScreen.getAvaialbleVersion().compareTo(new Version(VERSION)) > 0) {
        replace.add(ANCHOR_DOWNLOAD_DUMP3 + VERSION + ANCHOR_END);
        msg = 77;
      } else {
        replace.add(VERSION);
        msg = 39;
      }
      lnkVersion.setText(Messages.getString(DuMP3.class, msg, replace));
      lnkVersion.addListener(SWT.Selection, new Listener() {
        public void handleEvent(final Event event) {
          Program.launch(event.text);
        }
      });
      final FormData labelVersionLData = new FormData();
      labelVersionLData.width = 231;
      labelVersionLData.height = 21;
      labelVersionLData.left = new FormAttachment(700, 1000, 0);
      labelVersionLData.right = new FormAttachment(1000, 1000, -12); // Mac OS X fix
      labelVersionLData.top = new FormAttachment(1000, 1000, -23);
      labelVersionLData.bottom = new FormAttachment(1000, 1000, -2);
      lnkVersion.setLayoutData(labelVersionLData);
    }
    return lnkVersion;
  }

  /**
   * @return ProgressBar
   */
  private ProgressBar getProgressBar() {
    if (progressBar == null) {
      progressBar = new ProgressBar(buttonBar, SWT.SMOOTH);
      final FormData progressBarLData = new FormData();
      progressBarLData.width = 400;
      progressBarLData.height = 26;
      progressBarLData.left = new FormAttachment(0, 1000, 5);
      progressBarLData.top = new FormAttachment(0, 1000, 1);
      progressBarLData.right = new FormAttachment(434, 1000, 0);
      progressBarLData.bottom = new FormAttachment(1000, 1000, -1);
      progressBar.setLayoutData(progressBarLData);
      progressBar.setSelection(0);
      progress = 0.0;
    }
    return progressBar;
  }

  /**
   * @return cTabItem1
   */
  private CTabItem getTabItem1() {
    if (cTabItem1 == null) {
      cTabItem1 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem1.setText(Messages.getString(DuMP3.class, 66));
      getComposite1();
    }
    return cTabItem1;
  }

  /**
   * @return cTabItem2
   */
  private CTabItem getTabItem2() {
    if (cTabItem2 == null) {
      cTabItem2 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem2.setText(Messages.getString(DuMP3.class, 67));
      getComposite2();
    }
    return cTabItem2;
  }

  /**
   * @return cTabItem3
   */
  private CTabItem getTabItem3() {
    if (cTabItem3 == null) {
      cTabItem3 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem3.setText(Messages.getString(DuMP3.class, 68));
      getComposite3();
    }
    return cTabItem3;
  }

  /**
   * @return cTabItem4
   */
  private CTabItem getTabItem4() {
    if (cTabItem4 == null) {
      cTabItem4 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem4.setText(Messages.getString(DuMP3.class, 69));
    }
    return cTabItem4;
  }

  /**
   * @return cTabItem5
   */
  private CTabItem getTabItem5() {
    if (cTabItem5 == null) {
      cTabItem5 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem5.setText(Messages.getString(DuMP3.class, 70));
      getComposite5();
    }
    return cTabItem5;
  }

  /**
   * @return cTabItem6
   */
  private CTabItem getTabItem6() {
    if (cTabItem6 == null) {
      cTabItem6 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem6.setText(Messages.getString(DuMP3.class, 71));
    }
    return cTabItem6;
  }

  /**
   * @return cTabItem7
   */
  private CTabItem getTabItem7() {
    if (cTabItem7 == null) {
      cTabItem7 = new CTabItem(ctfMainTab, SWT.NONE);
      cTabItem7.setText(Messages.getString(DuMP3.class, 78));
    }
    return cTabItem7;
  }

  /**
   * @return TableViewer
   */
  private TableViewer getTableViewerFingerprintConfig() {
    if (tableViewerFingerprintConfig == null) {
      tableViewerFingerprintConfig = new TableViewer(composite3, SWT.BORDER | SWT.FULL_SELECTION | SWT.SINGLE);
      final FormData tableViewer4LData = new FormData();
      tableViewer4LData.width = 323;
      tableViewer4LData.height = 302;
      tableViewer4LData.left = new FormAttachment(563, 1000, 0);
      tableViewer4LData.right = new FormAttachment(1000, 1000, -5);
      tableViewer4LData.bottom = new FormAttachment(495, 1000, 0);
      tableViewer4LData.top = new FormAttachment(0, 1000, 7);
      tableViewerFingerprintConfig.getControl().setLayoutData(tableViewer4LData);
      tableViewerFingerprintConfig.getTable().setHeaderVisible(true);
      tableViewerFingerprintConfig.getTable().addListener(SWT.KeyUp, listener);
      final TableColumn column1 = new TableColumn(tableViewerFingerprintConfig.getTable(), SWT.LEFT);
      column1.setText(Messages.getString(DuMP3.class, 45));
      column1.setWidth(160);
      final TableColumn column2 = new TableColumn(tableViewerFingerprintConfig.getTable(), SWT.LEFT);
      column2.setText(Messages.getString(DuMP3.class, 46));
      column2.setWidth(160);
      tableViewerFingerprintConfig.setContentProvider(new ConfigContentProvider());
      tableViewerFingerprintConfig.setLabelProvider(new ConfigLabelProvider());
      tableViewerFingerprintConfig.setColumnProperties(new String[]{
        PROPERTY, VALUE
      });
      /**
       * <code>
       tableViewerFingerprintConfig.setCellModifier(new ICellModifier() {
       public boolean canModify(Object pElement, String property) {
       if (property.equals(VALUE)) {
       return true;
       }
       return false;
       }

       public Object getValue(Object pElement, String property) {
       if (property.equals(VALUE)) {
       return ((ConfigProperty)pElement).getValue();
       }
       return null;
       }

       public void modify(Object pElement, String property, Object pValue) {
       if (property.equals(VALUE)) {
       ((ConfigProperty)((TableItem)pElement).getData()).setValue(pValue);
       }
       }
       });
       </code>
       */
    }
    return tableViewerFingerprintConfig;
  }

  /**
   * @return TableViewer
   */
  private TableViewer getTableViewerFingerprintExtensions() {
    if (tableViewerFingerprintExtensions == null) {
      tableViewerFingerprintExtensions = new TableViewer(composite3, SWT.BORDER | SWT.FULL_SELECTION | SWT.SINGLE);
      final FormData tableViewer5LData = new FormData();
      tableViewer5LData.width = 323;
      tableViewer5LData.height = 302;
      tableViewer5LData.left = new FormAttachment(563, 1000, 0);
      tableViewer5LData.right = new FormAttachment(1000, 1000, -5);
      tableViewer5LData.top = new FormAttachment(505, 1000, 0);
      tableViewer5LData.bottom = new FormAttachment(994, 1000, 0);
      tableViewerFingerprintExtensions.getControl().setLayoutData(tableViewer5LData);
      tableViewerFingerprintExtensions.getTable().setHeaderVisible(true);
      tableViewerFingerprintExtensions.getTable().addListener(SWT.KeyUp, listener);
      final TableColumn tableColumn1;
      tableColumn1 = new TableColumn(tableViewerFingerprintExtensions.getTable(), SWT.LEFT);
      tableColumn1.setText(Messages.getString(DuMP3.class, 37));
      tableColumn1.setWidth(320);
    }
    return tableViewerFingerprintExtensions;
  }

  /**
   * @return TableViewer
   */
  public TableViewer getTableViewerFingerprintTypes() {
    if (tableViewerFingerprintTypes == null) {
      tableViewerFingerprintTypes = new TableViewer(composite3, SWT.BORDER | SWT.FULL_SELECTION | SWT.SINGLE);
      final FormData tableViewer3LData = new FormData();
      tableViewer3LData.width = 67;
      tableViewer3LData.height = 63;
      tableViewer3LData.left = new FormAttachment(0, 1000, 3);
      tableViewer3LData.top = new FormAttachment(0, 1000, 7);
      tableViewer3LData.right = new FormAttachment(434, 1000, 0);
      tableViewer3LData.bottom = new FormAttachment(994, 1000, 0);
      tableViewerFingerprintTypes.getControl().setLayoutData(tableViewer3LData);
      tableViewerFingerprintTypes.getTable().setHeaderVisible(true);
      tableViewerFingerprintTypes.getTable().addListener(SWT.KeyUp, listener);
      final TableColumn column1 = new TableColumn(tableViewerFingerprintTypes.getTable(), SWT.LEFT);
      column1.setText(Messages.getString(DuMP3.class, 43));
      column1.setWidth(200);
      final TableColumn column2 = new TableColumn(tableViewerFingerprintTypes.getTable(), SWT.RIGHT);
      column2.setText(Messages.getString(DuMP3.class, 44));
      column2.setWidth(120);
      tableViewerFingerprintTypes.setContentProvider(new CollectionTableContentProvider());
      tableViewerFingerprintTypes.setLabelProvider(new FingerprintTableLabelProvider());
      tableViewerFingerprintTypes.setSorter(new StringSorter());
      tableViewerFingerprintTypes.setInput(prints);
      tableViewerFingerprintTypes.addSelectionChangedListener(new ISelectionChangedListener() {
        public void selectionChanged(final SelectionChangedEvent pArg0) {
          tableViewer3WidgetSelected(pArg0);
        }
      });
    }
    return tableViewerFingerprintTypes;
  }

  /**
   * @return TableViewer
   */
  public TableViewer getTableViewerFoundExtensions() {
    if (tableViewerFoundExtensions == null) {
      tableViewerFoundExtensions = new TableViewer(composite2, SWT.BORDER | SWT.FULL_SELECTION | SWT.MULTI);
      final FormData listViewer1LData = new FormData();
      listViewer1LData.width = 67;
      listViewer1LData.height = 63;
      listViewer1LData.left = new FormAttachment(0, 1000, 3);
      listViewer1LData.top = new FormAttachment(0, 1000, 7);
      listViewer1LData.right = new FormAttachment(434, 1000, 0);
      listViewer1LData.bottom = new FormAttachment(994, 1000, 0);
      tableViewerFoundExtensions.getControl().setLayoutData(listViewer1LData);
      tableViewerFoundExtensions.getTable().setHeaderVisible(true);
      tableViewerFoundExtensions.getTable().addListener(SWT.KeyUp, listener);
      final TableColumn column1 = new TableColumn(tableViewerFoundExtensions.getTable(), SWT.LEFT);
      column1.setText(Messages.getString(DuMP3.class, 40));
      column1.setWidth(160);
      final TableColumn column2 = new TableColumn(tableViewerFoundExtensions.getTable(), SWT.RIGHT);
      column2.setText(Messages.getString(DuMP3.class, 41));
      column2.setWidth(160);
      tableViewerFoundExtensions.setContentProvider(new CollectionTableContentProvider());
      tableViewerFoundExtensions.setLabelProvider(new TypeTableLabelProvider());
      tableViewerFoundExtensions.setSorter(new ExtensionCountSorter(ExtensionCountSorter.EXT, ExtensionCountSorter.ASC));
      tableViewerFoundExtensions.setInput(typeList);
      column1.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent e) {
          if (((ExtensionCountSorter)tableViewerFoundExtensions.getSorter()).getType() == ExtensionCountSorter.COUNT) {
            tableViewerFoundExtensions.setSorter(new ExtensionCountSorter(ExtensionCountSorter.EXT, ExtensionCountSorter.ASC));
          } else {
            if (((ExtensionCountSorter)tableViewerFoundExtensions.getSorter()).getDirection() == ExtensionCountSorter.ASC) {
              tableViewerFoundExtensions.setSorter(new ExtensionCountSorter(ExtensionCountSorter.EXT, ExtensionCountSorter.DESC));
            } else {
              tableViewerFoundExtensions.setSorter(new ExtensionCountSorter(ExtensionCountSorter.EXT, ExtensionCountSorter.ASC));
            }
          }
        }
      });
      column2.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent e) {
          if (((ExtensionCountSorter)tableViewerFoundExtensions.getSorter()).getType() == ExtensionCountSorter.EXT) {
            tableViewerFoundExtensions.setSorter(new ExtensionCountSorter(ExtensionCountSorter.COUNT, ExtensionCountSorter.DESC));
          } else {
            if (((ExtensionCountSorter)tableViewerFoundExtensions.getSorter()).getDirection() == ExtensionCountSorter.DESC) {
              tableViewerFoundExtensions.setSorter(new ExtensionCountSorter(ExtensionCountSorter.COUNT, ExtensionCountSorter.ASC));
            } else {
              tableViewerFoundExtensions.setSorter(new ExtensionCountSorter(ExtensionCountSorter.COUNT, ExtensionCountSorter.DESC));
            }
          }
        }
      });
    }
    return tableViewerFoundExtensions;
  }

  /**
   * @return TableViewer
   */
  private TableViewer getTableViewerSelectedExtensions() {
    if (tableViewerSelectedExtensions == null) {
      tableViewerSelectedExtensions = new TableViewer(composite2, SWT.BORDER | SWT.FULL_SELECTION | SWT.MULTI);
      final FormData tableViewer2LData = new FormData();
      tableViewer2LData.width = 12;
      tableViewer2LData.height = 61;
      tableViewer2LData.left = new FormAttachment(559, 1000, 0);
      tableViewer2LData.right = new FormAttachment(1000, 1000, -6);
      tableViewer2LData.bottom = new FormAttachment(994, 1000, 0);
      tableViewer2LData.top = new FormAttachment(0, 1000, 6);
      tableViewerSelectedExtensions.getControl().setLayoutData(tableViewer2LData);
      tableViewerSelectedExtensions.getTable().setHeaderVisible(true);
      tableViewerSelectedExtensions.getTable().addListener(SWT.KeyUp, listener);
      final TableColumn column1 = new TableColumn(tableViewerSelectedExtensions.getTable(), SWT.LEFT);
      column1.setText(Messages.getString(DuMP3.class, 42));
      column1.setWidth(320);
      tableViewerSelectedExtensions.setContentProvider(new CollectionTableContentProvider());
      tableViewerSelectedExtensions.setLabelProvider(new TypeTableLabelProvider());
      tableViewerSelectedExtensions.setSorter(new StringSorter());
      tableViewerSelectedExtensions.setInput(selectedTypeList);
    }
    return tableViewerSelectedExtensions;
  }

  /**
   * @return ToolBar
   */
  public ToolBar getToolBarLeft() {
    if (toolBarLeft == null) {
      toolBarLeft = new ToolBar(composite5right, SWT.BORDER);
      final FormData toolBar1LData = new FormData();
      toolBar1LData.width = 248;
      toolBar1LData.height = 31;
      toolBar1LData.left = new FormAttachment(0, 1000, 0);
      toolBar1LData.top = new FormAttachment(sash5right, 0);
      toolBar1LData.bottom = new FormAttachment(sash5right, 31);
      toolBar1LData.right = new FormAttachment(500, 1000, -14);
      toolBarLeft.setLayoutData(toolBar1LData);
      getToolItemLDelete();
      getToolItemLTrash();
      getToolItemLMove();
    }
    return toolBarLeft;
  }

  /**
   * @return ToolBar
   */
  public ToolBar getToolBarRight() {
    if (toolBarRight == null) {
      toolBarRight = new ToolBar(composite5right, SWT.BORDER);
      final FormData toolBar1RData = new FormData();
      toolBar1RData.width = 255;
      toolBar1RData.height = 31;
      toolBar1RData.left = new FormAttachment(500, 1000, 14);
      toolBar1RData.top = new FormAttachment(sash5right, 0);
      toolBar1RData.bottom = new FormAttachment(sash5right, 31);
      toolBar1RData.right = new FormAttachment(1000, 1000, 0);
      toolBarRight.setLayoutData(toolBar1RData);
      getToolItemRDelete();
      getToolItemRTrash();
      getToolItemRMove();
    }
    return toolBarRight;
  }

  /**
   * @return ToolItem
   */
  public ToolItem getToolItemLDelete() {
    if (toolItemLDelete == null) {
      toolItemLDelete = new ToolItem(toolBarLeft, SWT.PUSH);
      listener.addMapping(SWT.CONTROL, 113, toolItemLDelete);
      toolItemLDelete.setImage(SWTResourceManager.getImage(Files.ICONS_REMOVE_GIF));
      toolItemLDelete.setToolTipText(Messages.getString(DuMP3.class, 72));
      toolItemLDelete.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemLDeleteWidgetSelected(evt);
        }
      });
    }
    return toolItemLDelete;
  }

  /**
   * @return ToolItem
   */
  public ToolItem getToolItemLMove() {
    if (toolItemLMove == null) {
      toolItemLMove = new ToolItem(toolBarLeft, SWT.PUSH);
      listener.addMapping(SWT.CONTROL, 101, toolItemLMove);
      toolItemLMove.setImage(SWTResourceManager.getImage(Files.ICONS_MOVE_GIF));
      toolItemLMove.setToolTipText(Messages.getString(DuMP3.class, 74));
      toolItemLMove.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemLMoveWidgetSelected(evt);
        }
      });
    }
    return toolItemLMove;
  }

  /**
   * @return ToolItem
   */
  public ToolItem getToolItemLTrash() {
    if (toolItemLTrash == null) {
      toolItemLTrash = new ToolItem(toolBarLeft, SWT.PUSH);
      listener.addMapping(SWT.CONTROL, 119, toolItemLTrash);
      toolItemLTrash.setImage(SWTResourceManager.getImage(Files.ICONS_TRASH_CAN_GIF));
      toolItemLTrash.setToolTipText(Messages.getString(DuMP3.class, 73));
      toolItemLTrash.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemLTrashWidgetSelected(evt);
        }
      });
    }
    return toolItemLTrash;
  }

  /**
   * @return ToolItem - Returns the toolItemRDelete.
   */
  public ToolItem getToolItemRDelete() {
    if (toolItemRDelete == null) {
      toolItemRDelete = new ToolItem(toolBarRight, SWT.PUSH);
      listener.addMapping(SWT.CONTROL, 105, toolItemRDelete);
      toolItemRDelete.setImage(SWTResourceManager.getImage(Files.ICONS_REMOVE_GIF));
      toolItemRDelete.setToolTipText(Messages.getString(DuMP3.class, 92));
      toolItemRDelete.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemRDeleteWidgetSelected(evt);
        }
      });
    }
    return toolItemRDelete;
  }

  /**
   * @return ToolItem - Returns the toolItemRMove.
   */
  public ToolItem getToolItemRMove() {
    if (toolItemRMove == null) {
      toolItemRMove = new ToolItem(toolBarRight, SWT.PUSH);
      listener.addMapping(SWT.CONTROL, 112, toolItemRMove);
      toolItemRMove.setImage(SWTResourceManager.getImage(Files.ICONS_MOVE_GIF));
      toolItemRMove.setToolTipText(Messages.getString(DuMP3.class, 94));
      toolItemRMove.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemRMoveWidgetSelected(evt);
        }
      });
    }
    return toolItemRMove;
  }

  /**
   * @return ToolItem - Returns the toolItemRTrash.
   */
  public ToolItem getToolItemRTrash() {
    if (toolItemRTrash == null) {
      toolItemRTrash = new ToolItem(toolBarRight, SWT.PUSH);
      listener.addMapping(SWT.CONTROL, 111, toolItemRTrash);
      toolItemRTrash.setImage(SWTResourceManager.getImage(Files.ICONS_TRASH_CAN_GIF));
      toolItemRTrash.setToolTipText(Messages.getString(DuMP3.class, 93));
      toolItemRTrash.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(final SelectionEvent evt) {
          toolItemRTrashWidgetSelected(evt);
        }
      });
    }
    return toolItemRTrash;
  }

  /**
   * This method ...
   * 
   * @return TreeViewer
   */
  private TreeViewer getTreeViewerCompareResults() {
    if (treeViewerCompareResults == null) {
      treeViewerCompareResults = new TreeViewer(composite5, SWT.BORDER | SWT.MULTI);
      final FormData treeViewer3LData = new FormData();
      treeViewer3LData.width = 232;
      treeViewer3LData.height = 484;
      treeViewer3LData.left = new FormAttachment(0, 1000, 3);
      treeViewer3LData.top = new FormAttachment(0, 1000, 6);
      if (horizontalLayout) {
        treeViewer3LData.bottom = new FormAttachment(sash5, 0);
        treeViewer3LData.right = new FormAttachment(994, 1000, 0);
      } else {
        treeViewer3LData.bottom = new FormAttachment(994, 1000, 0);
        treeViewer3LData.right = new FormAttachment(sash5, 0);
      }
      treeViewerCompareResults.getControl().setLayoutData(treeViewer3LData);
      final TreeColumn column = new TreeColumn(treeViewerCompareResults.getTree(), SWT.LEFT);
      column.setText(Messages.getString(DuMP3.class, 49));
      column.setWidth(800);
      treeViewerCompareResults.setContentProvider(new FingerprintTreeContentProvider());
      treeViewerCompareResults.setLabelProvider(new FingerprintTreeLabelProvider());
      treeViewerCompareResults.setInput(duplicateList);
      treeViewerCompareResults.getTree().setHeaderVisible(true);
      treeViewerCompareResults.getTree().addListener(SWT.KeyUp, listener);
      treeViewerCompareResults.addPostSelectionChangedListener(new ISelectionChangedListener() {
        public void selectionChanged(final SelectionChangedEvent evt) {
          treeViewer3SelectionChanged(evt);
        }
      });
    }
    return treeViewerCompareResults;
  }

  /**
   * @return TreeViewer
   */
  public TreeViewer getTreeViewerMyComputer() {
    if (treeViewerMyComputer == null) {
      treeViewerMyComputer = new TreeViewer(composite1, SWT.BORDER | SWT.MULTI);
      final FormData treeViewer1LData = new FormData();
      treeViewer1LData.width = 326;
      treeViewer1LData.height = 493;
      treeViewer1LData.left = new FormAttachment(0, 1000, 3);
      treeViewer1LData.top = new FormAttachment(0, 1000, 6);
      treeViewer1LData.bottom = new FormAttachment(994, 1000, 0);
      treeViewer1LData.right = new FormAttachment(434, 1000, 0);
      final TreeColumn column = new TreeColumn(treeViewerMyComputer.getTree(), SWT.LEFT);
      column.setText(Messages.getString(DuMP3.class, 47));
      column.setWidth(320);
      treeViewerMyComputer.getControl().setLayoutData(treeViewer1LData);
      treeViewerMyComputer.getTree().setBounds(0, 0, 346, 513);
      treeViewerMyComputer.setContentProvider(new FileTreeContentProvider());
      treeViewerMyComputer.setLabelProvider(new FileTreeLabelProvider());
      treeViewerMyComputer.setInput(new File(Strings.STAR));
      treeViewerMyComputer.getTree().setHeaderVisible(true);
      treeViewerMyComputer.getTree().addListener(SWT.KeyUp, listener);
      // treeViewerMyComputer.addFilter(new AllowOnlyFoldersFilter());
    }
    return treeViewerMyComputer;
  }

  /**
   * @return TreeViewer
   */
  public TreeViewer getTreeViewerSelectedFiles() {
    if (treeViewerSelectedFiles == null) {
      treeViewerSelectedFiles = new TreeViewer(composite1, SWT.BORDER | SWT.MULTI);
      final FormData treeViewer2LData = new FormData();
      treeViewer2LData.width = 326;
      treeViewer2LData.height = 493;
      treeViewer2LData.left = new FormAttachment(559, 1000, 0);
      treeViewer2LData.right = new FormAttachment(1000, 1000, -6);
      treeViewer2LData.bottom = new FormAttachment(994, 1000, 0);
      treeViewer2LData.top = new FormAttachment(0, 1000, 6);
      final TreeColumn column = new TreeColumn(treeViewerSelectedFiles.getTree(), SWT.LEFT);
      column.setText(Messages.getString(DuMP3.class, 48));
      column.setWidth(320);
      treeViewerSelectedFiles.getControl().setLayoutData(treeViewer2LData);
      treeViewerSelectedFiles.getTree().setBounds(450, 0, 346, 513);
      treeViewerSelectedFiles.setContentProvider(new ListTreeContentProvider());
      treeViewerSelectedFiles.setLabelProvider(new FileListLabelProvider());
      treeViewerSelectedFiles.setInput(fileList);
      treeViewerSelectedFiles.getTree().setHeaderVisible(true);
      treeViewerSelectedFiles.getTree().addListener(SWT.KeyUp, listener);
      // treeViewerSelectedFiles.addFilter(new AllowOnlyFoldersFilter());
    }
    return treeViewerSelectedFiles;
  }

  /**
   * This method hides all result displays
   */
  void hideDisplays() {
    getComposite5topImage().setVisible(false);
    ((DoubleDisplay)getComposite5topImage()).display(null, null);
    getComposite5topText().setVisible(false);
    ((DoubleDisplay)getComposite5topText()).display(null, null);
    // getComposite5topAudio().setVisible(false);
    // getComposite5topBinary().setVisible(false);
    ((DoubleInfo)getComposite5bottomInfo()).display(null, null);
  }

  /**
   * Initializes the GUI.
   */
  private void initGUI() {
    try {
      this.setSize(new org.eclipse.swt.graphics.Point(800, 600));
      this.setBackground(null);
      final FormLayout thisLayout = new FormLayout();
      setLayout(thisLayout);
      getButtonBar();
      {
        ctfMainTab = new CTabFolder(this, SWT.NONE);
        final FormData ctfMainTabLData = new FormData();
        ctfMainTabLData.width = 396;
        ctfMainTabLData.height = 778;
        ctfMainTabLData.top = new FormAttachment(0, 1000, 0);
        ctfMainTabLData.left = new FormAttachment(0, 1000, 0);
        ctfMainTabLData.right = new FormAttachment(1000, 1000, 0);
        ctfMainTabLData.bottom = new FormAttachment(1000, 1000, -65);
        ctfMainTab.setLayoutData(ctfMainTabLData);
        getTabItem1();
        getTabItem2();
        getTabItem3();
        getTabItem4();
        getTabItem5();
        getTabItem6();
        getTabItem7();
        ctfMainTab.setSelection(0);
        ctfMainTab.addSelectionListener(new SelectionAdapter() {
          @Override
          public void widgetSelected(final SelectionEvent evt) {
            ctfMainTabWidgetSelected(evt);
          }
        });
      }
      getLblStatus();
      getLnkVersion();
      this.layout();
    } catch (final Exception e) {
      log.error(Debug.getString(DuMP3.class, 50), e);
    }
  }

  /**
   * This method refreshes the results tree<br>
   * BUG 1548859 - Lost context
   */
  public void refreshResults() {
    display.asyncExec(new Runnable() {
      @SuppressWarnings("unchecked")
      public void run() {
        synchronized (treeViewerCompareResults) {
          List<FingerprintFile> ffl = null;
          final StructuredSelection ss = (StructuredSelection)treeViewerCompareResults.getSelection();
          if ((ss != null) && !ss.isEmpty()) {
            ffl = ss.toList();
          }
          duplicateList.clear();
          duplicateList.addAll(Comparer.getInstance().getDuplicates());
          treeViewerCompareResults.refresh();
          if (treeViewerCompareResults.getTree().getItemCount() > 0) {
            if (ffl == null) {
              ffl = new ArrayList<FingerprintFile>();
              ffl.add((FingerprintFile)treeViewerCompareResults.getTree().getItem(0).getData());
            }
            treeViewerCompareResults.setSelection(new StructuredSelection(ffl), true);
            final StructuredSelection ss1 = (StructuredSelection)treeViewerCompareResults.getSelection();
            if ((ss1 == null) || ss1.isEmpty()) {
              ffl = new ArrayList<FingerprintFile>();
              ffl.add((FingerprintFile)treeViewerCompareResults.getTree().getItem(0).getData());
              treeViewerCompareResults.setSelection(new StructuredSelection(ffl), true);
            }
          }
        }
      }
    });
  }

  /**
   * @see net.za.grasser.duplicate.gui.IDisplay#setStatus(java.lang.String)
   */
  public void setStatus(final String pStatus) {
    display.asyncExec(new Runnable() {
      public void run() {
        synchronized (lblStatus) {
          if (!lblStatus.isDisposed()) {
            lblStatus.setText(pStatus);
          }
        }
      }
    });
  }

  /**
   * This method will change the input in the config edit table.
   * 
   * @param evt
   */
  void tableViewer3WidgetSelected(final SelectionChangedEvent evt) {
    final IStructuredSelection selection = (IStructuredSelection)evt.getSelection();
    if (!selection.isEmpty()) {
      final Object first = selection.getFirstElement();
      tableViewerFingerprintConfig.setInput(first);
    }
  }

  /**
   * This method ...
   * 
   * @param evt
   */
  void toolItemLDeleteWidgetSelected(final SelectionEvent evt) {
    final FingerprintFile f = (FingerprintFile)evt.widget.getData();
    if (f == null) {
      return;
    }
    final FileUtils.Result r = FileUtils.getInstance(getShell()).deleteFile(f);
    lblStatus.setText(r.message);
    if (r.state) {
      Comparer.getInstance().removeFile(f);
      refreshResults();
    }
  }

  /**
   * This method ...
   * 
   * @param evt
   */
  void toolItemLMoveWidgetSelected(final SelectionEvent evt) {
    final FingerprintFile f = (FingerprintFile)evt.widget.getData();
    if (f == null) {
      return;
    }
    final FileUtils.Result r = FileUtils.getInstance(getShell()).moveFile(f);
    lblStatus.setText(r.message);
    if (r.state) {
      Comparer.getInstance().removeFile(f);
      refreshResults();
    }
  }

  /**
   * This method ...
   * 
   * @param evt
   */
  void toolItemLTrashWidgetSelected(final SelectionEvent evt) {
    final FingerprintFile f = (FingerprintFile)evt.widget.getData();
    if (f == null) {
      return;
    }
    final FileUtils.Result r = FileUtils.getInstance(getShell()).trashFile(f);
    lblStatus.setText(r.message);
    if (r.state) {
      Comparer.getInstance().removeFile(f);
      refreshResults();
    }
  }

  /**
   * This method ...
   * 
   * @param evt
   */
  void toolItemRDeleteWidgetSelected(final SelectionEvent evt) {
    final FingerprintFile f = (FingerprintFile)evt.widget.getData();
    if (f == null) {
      return;
    }
    final FileUtils.Result r = FileUtils.getInstance(getShell()).deleteFile(f);
    lblStatus.setText(r.message);
    if (r.state) {
      Comparer.getInstance().removeFile(f);
      refreshResults();
    }
  }

  /**
   * This method ...
   * 
   * @param evt
   */
  void toolItemRMoveWidgetSelected(final SelectionEvent evt) {
    final FingerprintFile f = (FingerprintFile)evt.widget.getData();
    if (f == null) {
      return;
    }
    final FileUtils.Result r = FileUtils.getInstance(getShell()).moveFile(f);
    lblStatus.setText(r.message);
    if (r.state) {
      Comparer.getInstance().removeFile(f);
      refreshResults();
    }
  }

  /**
   * This method ...
   * 
   * @param evt
   */
  void toolItemRTrashWidgetSelected(final SelectionEvent evt) {
    final FingerprintFile f = (FingerprintFile)evt.widget.getData();
    if (f == null) {
      return;
    }
    final FileUtils.Result r = FileUtils.getInstance(getShell()).trashFile(f);
    lblStatus.setText(r.message);
    if (r.state) {
      Comparer.getInstance().removeFile(f);
      refreshResults();
    }
  }

  /**
   * This method will change the selection of treeViewerCompareResults
   * 
   * @param pLeft
   * @param pRight
   */
  private void treeViewer3ChangeSelection(final FingerprintFile pLeft, final FingerprintFile pRight) {
    if ((pLeft == null) || (pRight == null)) {
      return;
    }
    display.asyncExec(new Runnable() {
      public void run() {
        final List<FingerprintFile> sel = new ArrayList<FingerprintFile>();
        sel.add(pLeft);
        sel.add(pRight);
        synchronized (treeViewerCompareResults) {
          treeViewerCompareResults.expandToLevel(pLeft, AbstractTreeViewer.ALL_LEVELS);
          treeViewerCompareResults.reveal(pRight);
          treeViewerCompareResults.setSelection(new StructuredSelection(sel), true);
        }
      }
    });
  }

  /**
   * This method shows the files in the right pane.<BR>
   * BUG 1548859 - Lost context
   * 
   * @param evt
   */
  @SuppressWarnings("unchecked")
  void treeViewer3SelectionChanged(final SelectionChangedEvent evt) {
    final IStructuredSelection selection = (IStructuredSelection)evt.getSelection();
    if ((selection == null) || selection.isEmpty()) {
      hideDisplays();
      return;
    }
    FingerprintFile left = null;
    FingerprintFile right = null;
    final List<FingerprintFile> sel = selection.toList();
    if (sel.size() > 1) {
      left = sel.get(0);
      right = sel.get(1);
      if (sel.size() > 2) {
        // only two files selected at once
        treeViewer3ChangeSelection(left, right);
        return;
      }
    } else {
      final FingerprintFile first = (FingerprintFile)selection.getFirstElement();
      // work out left and right file
      if (first.getCompared() == null) {
        // top element - first build is right
        left = first;
        right = first.getDuplicates().get(0);
      } else {
        // a compared element - parent is left
        left = first.getCompared();
        right = first;
      }
      treeViewer3ChangeSelection(left, right);
      return;
    }
    if ((left == prevLeft) && (right == prevRight)) {
      // keep context
      return;
    }
    prevLeft = left;
    prevRight = right;
    displayCompare(left, right);
  }
  
  /**
   * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
   */
  public void update(final Observable pO, final Object pArg) {
    if (pArg instanceof FingerprintFile) {
      final FingerprintFile ff = (FingerprintFile)pArg;
      if ((ff.getDuplicates() != null) && !ff.getDuplicates().isEmpty()) {
        refreshResults();
        return;
      }
      final String s = ff.getExtension();
      final boolean added;
      if (typeMap.containsKey(s)) {
        final ExtensionCount wild = typeMap.get(s);
        wild.incCount();
        added = false;
      } else {
        final ExtensionCount wild = new ExtensionCount(ff.getExtension());
        typeMap.put(s, wild);
        added = true;
      }
      display.asyncExec(new Runnable() {
        public void run() {
          if (!progressBar.isDisposed()) {
            if (added) {
              progress += 1.0;
            } else {
              progress += 0.1;
            }
            progressBar.setSelection((int)progress % 101);
          }
        }
      });
    } else if (pArg instanceof String) {
      if (pO instanceof Comparer) {
        display.asyncExec(new Runnable() {
          public void run() {
            if (!lblStatus.isDisposed()) {
              final List<String> replace = new ArrayList<String>();
              replace.add(String.valueOf(progressBar.getMaximum()));
              replace.add(speed(progress, startSpeed));
              lblStatus.setText(Messages.getString(DuMP3.class, 51, replace));
            }
            refreshResults();
            if (!ctfMainTab.isDisposed()) {
              ctfMainTab.setSelection(cTabItem5);
              // TODO fix once cleanup screen is done
              btnBack.setEnabled(true);
              btnBack.setText(Messages.getString(DuMP3.class, 35));
              btnNext.setEnabled(false);
            }
            if (!progressBar.isDisposed()) {
              progressBar.setSelection(0);
              progress = 0.0;
            }
          }
        });
        return;
      }
      typeThreadsStarted--;
      if (typeThreadsStarted <= 0) {
        typeList.clear();
        typeList.addAll(typeMap.values());
        try {
          Collections.sort(typeList);
        } catch (final Exception e) {
          log.error(Debug.getString(DuMP3.class, 52), e);
        }
        display.asyncExec(new Runnable() {
          public void run() {
            if (!lblStatus.isDisposed()) {
              lblStatus.setText(Messages.getString(DuMP3.class, 53));
            }
            tableViewerFoundExtensions.refresh();
            if (!ctfMainTab.isDisposed()) {
              ctfMainTab.setSelection(cTabItem2);
              btnBack.setEnabled(true);
              btnNext.setEnabled(false);
            }
            if (!progressBar.isDisposed()) {
              progressBar.setSelection(0);
              progress = 0.0;
            }
            if (!lblStatus.isDisposed()) {
              lblStatus.setText(Messages.getString(DuMP3.class, 54));
            }
          }
        });
      }
    } else if (pArg instanceof Integer) {
      display.asyncExec(new Runnable() {
        public void run() {
          if (!progressBar.isDisposed() && !lblStatus.isDisposed()) {
            synchronized (progressBar) {
              if (progress == 0.0) {
                // set start date
                startSpeed = new Date();
              }
              progress += ((Integer)pArg).doubleValue();
              progressBar.setSelection((int)progress);
              synchronized (lblStatus) {
                final List<String> replace = new ArrayList<String>();
                replace.add(String.valueOf(progressBar.getSelection()));
                replace.add(String.valueOf(progressBar.getMaximum()));
                replace.add(speed(progress, startSpeed));
                lblStatus.setText(Messages.getString(DuMP3.class, 55, replace));
              }
            }
          }
        }
      });
    }
  }
}