/**
 * DuMP3 version 0.3.2 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Toolkit;
import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JWindow;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.border.BevelBorder;

import jonelo.sugar.util.Base64;
import net.za.grasser.duplicate.util.Files;
import net.za.grasser.duplicate.util.Strings;
import net.za.grasser.duplicate.util.Version;
import net.za.grasser.duplicate.util.res.Debug;
import net.za.grasser.duplicate.util.res.Messages;

import org.apache.log4j.Logger;
import org.jconfig.Configuration;
import org.jconfig.ConfigurationManager;
import org.jconfig.ConfigurationManagerException;
import org.jconfig.handler.XMLFileHandler;

/**
 * This class displays a splash screen for a given period.<br>
 * Nabbed from <a href="http://www.java-tips.org/java-se-tips/javax.swing/how-to-implement-a-splash-screen-for-an-application.html">How to implement a splash
 * screen for an application</a>
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.19 $
 */
public class SplashScreen extends JWindow {
  /**
   * <code>PROXY_AUTHORIZATION</code> SplashScreen -
   */
  private static final String PROXY_AUTHORIZATION = "Proxy-Authorization"; //$NON-NLS-1$
  /**
   * <code>avaialbleVersion</code> SplashScreen -
   */
  private static Version avaialbleVersion = null;
  /**
   * <code>GENERAL</code> SplashScreen -
   */
  private static final String GENERAL = "general"; //$NON-NLS-1$
  /**
   * <code>log</code> SplashScreen -
   */
  static final Logger log = Logger.getLogger(SplashScreen.class);
  /**
   * <code>PROXY_PORT</code> SplashScreen -
   */
  private static final String PROXY_PORT = "proxy port"; //$NON-NLS-1$
  /**
   * <code>PROXY_SERVER</code> SplashScreen -
   */
  private static final String PROXY_SERVER = "proxy server"; //$NON-NLS-1$
  /**
   * <code>PROXY_USER</code> SplashScreen -
   */
  private static final String PROXY_USER = "proxy user"; //$NON-NLS-1$
  /**
   * <code>PROXY_PASSWORD</code> SplashScreen -
   */
  private static final String PROXY_PASSWORD = "proxy password"; //$NON-NLS-1$
  /**
   * <code>serialVersionUID</code> long -
   */
  private static final long serialVersionUID = 6124882603956758641L;
  /**
   * <code>SYSTEM_PROXY_HOST</code> SplashScreen -
   */
  private static final String SYSTEM_PROXY_HOST = "proxyHost"; //$NON-NLS-1$
  /**
   * <code>SYSTEM_PROXY_PORT</code> SplashScreen -
   */
  private static final String SYSTEM_PROXY_PORT = "proxyPort"; //$NON-NLS-1$
  /**
   * <code>SYSTEM_PROXY_SET</code> SplashScreen -
   */
  private static final String SYSTEM_PROXY_SET = "proxySet"; //$NON-NLS-1$
  /**
   * <code>VERSION</code> SplashScreen -
   */
  private static final String VERSION = "0.3.2"; //$NON-NLS-1$
  /**
   * <code>XML_VERSION</code> SplashScreen -
   */
  private static final String XML_VERSION = "version"; //$NON-NLS-1$

  /**
   * @return Version - Returns the avaialbleVersion.
   */
  public static Version getAvaialbleVersion() {
    return avaialbleVersion;
  }

  /**
   * <code>duration</code> SplashScreen -
   */
  private int duration;
  /**
   * <code>proxyPort</code> SplashScreen -
   */
  private String proxyPort = null;
  /**
   * <code>proxyServer</code> SplashScreen -
   */
  private String proxyServer = null;
  /**
   * <code>proxyUser</code> SplashScreen -
   */
  private String proxyUser = null;
  /**
   * <code>proxyPassword</code> SplashScreen -
   */
  private String proxyPassword = null;

  /**
   * Constructor
   * 
   * @param d duration in milliseconds.
   */
  public SplashScreen(final int d) {
    Configure.load();
    duration = d;
    proxyServer = Configure.getProperty(PROXY_SERVER, Strings.EMPTY, SplashScreen.class.getName());
    if (proxyServer.length() <= 0) {
      proxyServer = null;
    }
    proxyPort = Configure.getProperty(PROXY_PORT, Strings.EMPTY, SplashScreen.class.getName());
    if (proxyPort.length() <= 0) {
      proxyPort = null;
    }
    proxyUser = Configure.getProperty(PROXY_USER, Strings.EMPTY, SplashScreen.class.getName());
    if (proxyUser.length() <= 0) {
      proxyUser = null;
    }
    proxyPassword = Configure.getProperty(PROXY_PASSWORD, Strings.EMPTY, SplashScreen.class.getName());
    if (proxyPassword.length() <= 0) {
      proxyPassword = null;
    }
    if (proxyServer != null && proxyPort != null) {
      System.getProperties().put(SYSTEM_PROXY_SET, Strings.TRUE);
      System.getProperties().put(SYSTEM_PROXY_HOST, proxyServer);
      System.getProperties().put(SYSTEM_PROXY_PORT, proxyPort);
    }
  }

  /**
   * This method checks the version on the web server and displayse the appropriate message.
   * 
   * @return String
   */
  private String checkVersion() {
    getVersionFileFromServer();
    avaialbleVersion = getVersionFromFile();
    final Version tVer = new Version(VERSION);
    int msg = 2;
    final List<String> replace = new ArrayList<String>();
    if (tVer.compareTo(avaialbleVersion) < 0) {
      msg = 3;
      replace.add(avaialbleVersion.toString());
    } else if (tVer.compareTo(avaialbleVersion) > 0) {
      msg = 4;
      replace.add(avaialbleVersion.toString());
    } else {
      // ==
      msg = 2;
      replace.add(VERSION);
    }
    if (log.isDebugEnabled()) {
      log.debug(Debug.getString(SplashScreen.class, msg, replace));
    }
    return Messages.getString(SplashScreen.class, msg, replace);
  }

  /**
   * This method retrieves the version file from the server.
   */
  public void getVersionFileFromServer() {
    try {
      final HttpURLConnection con = (HttpURLConnection)new URL(Files.HTTP_VERSION_XML).openConnection();
      if (proxyUser != null && proxyPassword != null) {
        final String password = proxyUser + Strings.COLON + proxyPassword;
        con.setRequestProperty(PROXY_AUTHORIZATION, Base64.encodeBytes(password.getBytes()));
      }
      con.connect();
      final BufferedReader reader = new BufferedReader(new InputStreamReader(con.getInputStream()));
      final StringBuffer sb = new StringBuffer();
      String line = null;
      while ((line = reader.readLine()) != null) {
        sb.append(line);
      }
      final FileOutputStream out = new FileOutputStream(Files.VERSION_XML);
      out.write(sb.toString().getBytes());
      out.flush();
      out.close();
    } catch (final MalformedURLException e) {
      log.warn(Debug.getString(SplashScreen.class, 5), e);
    } catch (final IOException e) {
      log.warn(Debug.getString(SplashScreen.class, 5), e);
    }
  }

  /**
   * This method reads the XML version file and returns its version.
   * 
   * @return Version
   */
  public Version getVersionFromFile() {
    try {
      final XMLFileHandler handler = new XMLFileHandler(Files.VERSION_XML);
      final ConfigurationManager manager = ConfigurationManager.getInstance();
      manager.load(handler, XML_VERSION);
      final Configuration config = ConfigurationManager.getConfiguration(XML_VERSION);
      String ver = config.getProperty(XML_VERSION, Strings.EMPTY, XML_VERSION);
      if (ver.equals(Strings.EMPTY)) {
        ver = config.getProperty(XML_VERSION, Strings.EMPTY, GENERAL);
        if (ver.equals(Strings.EMPTY)) {
          ver = config.getProperty(XML_VERSION, Strings.EMPTY);
        }
      }
      return new Version(ver);
    } catch (final ConfigurationManagerException e) {
      log.warn(Debug.getString(SplashScreen.class, 5), e);
    }
    // could not read the file - return this version
    return new Version(VERSION);
  }

  /**
   * This method hides the splash screen
   */
  public void hideSplash() {
    setVisible(false);
  }

  /**
   * A simple little method to show a title screen in the center of the screen for the amount of time given in the constructor
   */
  public void showSplash() {
    final JPanel content = (JPanel)getContentPane();
    content.setBackground(Color.white);
    // Set the window's bounds, centering the window
    final int width = 350;
    final int height = 166;
    final Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
    final int x = (screen.width - width) / 2;
    final int y = (screen.height - height) / 2;
    setBounds(x, y, width, height);
    // Build the splash screen
    final JLabel label = new JLabel(new ImageIcon(Files.ICONS_SPLASH_GIF));
    final JLabel copyrt = new JLabel(Strings.COPYRIGHT, SwingConstants.CENTER);
    final JLabel version = new JLabel(Messages.getString(SplashScreen.class, 6), SwingConstants.CENTER);
    copyrt.setFont(new Font(Strings.FONT_ARIAL, Font.BOLD, 12));
    content.add(label, BorderLayout.NORTH);
    content.add(copyrt, BorderLayout.CENTER);
    content.add(version, BorderLayout.SOUTH);
    content.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED, new Color(152, 216, 250, 255), new Color(102, 137, 214, 255)));
    final int pause = duration;
    final Runnable closerRunner = new Runnable() {
      public void run() {
        setVisible(false);
        dispose();
      }
    };
    final Runnable waitRunner = new Runnable() {
      public void run() {
        try {
          Thread.sleep(pause);
          SwingUtilities.invokeAndWait(closerRunner);
        } catch (Exception e) {
          log.error(Debug.getString(SplashScreen.class, 1), e);
        }
      }
    };
    setVisible(true);
    version.setText(checkVersion());
    if (duration > 0) {
      final Thread splashThread = new Thread(waitRunner, Strings.SPLASH_THREAD);
      splashThread.start();
    }
  }
}