/**
 * DuMP3 version 0.3.2 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate.file;

import java.io.File;
import java.util.ArrayList;

import net.za.grasser.duplicate.util.Strings;

/**
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.9 $
 */
public class DirectoryInfo {
  /** @modelguid {D630C0C9-AA82-4855-B4A4-C4498723BD6B} */
  private String name;
  /**
   * <code>subdirs</code> DirectoryInfo - ArrayList of DirectoryInfo objects.
   */
  private ArrayList<DirectoryInfo> subdirs;
  /**
   * <code>files</code> DirectoryInfo - ArrayList of MDFingerprint objects.
   */
  private ArrayList<FingerprintFile> files;
  /** @modelguid {A31A8F69-65A6-417D-9E7B-19D8742E1DB4} */
  private DirectoryInfo parent;

  /**
   * @param pName String
   */
  public DirectoryInfo(final String pName) {
    name = pName;
  }

  /**
   * @return ArrayList of FingerprintFile objects.
   */
  public ArrayList<FingerprintFile> getFiles() {
    return files;
  }

  /**
   * @return String - name of this derectory.
   */
  public String getName() {
    return name;
  }

  /**
   * @return DirectoryInfo - the parent dir.
   */
  public DirectoryInfo getParent() {
    return parent;
  }

  /**
   * @return ArrayList of DirectoryInfo objects.
   */
  public ArrayList<DirectoryInfo> getSubDirectories() {
    return subdirs;
  }

  /**
   * @param vector ArrayList of MDFingerprint objects.
   */
  public void setFiles(final ArrayList<FingerprintFile> vector) {
    files = vector;
  }

  /**
   * @param string
   */
  public void setName(final String string) {
    name = string;
  }

  /**
   * @param info
   */
  public void setParent(final DirectoryInfo info) {
    parent = info;
  }

  /**
   * @param vector - ArrayList of DirectoryInfo objects.
   */
  public void setSubDirectories(final ArrayList<DirectoryInfo> vector) {
    subdirs = vector;
  }

  /**
   * @return String
   */
  public String getPath() {
    final StringBuffer ret = new StringBuffer(100);
    ret.append(name);
    DirectoryInfo p = getParent();
    while (p != null) {
      if (p.getName().endsWith(Strings.SLASH) || p.getName().endsWith(File.separator)) {
        ret.insert(0, p.getName());
      } else {
        ret.insert(0, File.separator);
        ret.insert(0, p.getName());
      }
      p = p.getParent();
    }
    if ((ret.lastIndexOf(Strings.SLASH) != ret.length() - 1) && (ret.lastIndexOf(File.separator) != ret.length() - 1)) {
      ret.append(File.separator);
    }
    return ret.toString();
  }
}
