/**
 * DuMP3 version 0.3.2 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate.gui;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;

import net.za.grasser.duplicate.util.Chars;
import net.za.grasser.duplicate.util.Files;
import net.za.grasser.duplicate.util.Strings;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

import com.cloudgarden.resource.SWTResourceManager;

/**
 * This class ...
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.11 $
 */
public class FileListLabelProvider extends LabelProvider {
  /**
   * @see org.eclipse.jface.viewers.LabelProvider#getText(java.lang.Object)
   */
  @Override
  public String getText(final Object element) {
    final File f = (File)element;
    final StringBuffer s = new StringBuffer();
    s.append(f.getPath());
    if (f.getName().length() == 0) {
      try {
        final String a = f.getPath().substring(0, (f.getPath().length() - 1));
        final Process proc = Runtime.getRuntime().exec((Strings.NET_USE + a));
        final BufferedReader br = new BufferedReader(new InputStreamReader(proc.getInputStream()));
        String line = null;
        while ((line = br.readLine()) != null) {
          if (line.indexOf(Strings.BSLASH_BSLASH) >= 0) {
            s.append(a).append(Chars.SPACE).append(Chars.OPN_BRACKET).append(line.substring(line.indexOf(Chars.BSLASH))).append(
              Chars.CLS_BRACKET);
          }
        }
        proc.waitFor();
        if (s.length() == 0) {
          s.append(a);
        }
      } catch (final Exception e) {
        e.printStackTrace();
      }
    }
    return s.toString();
  }

  /**
   * @see org.eclipse.jface.viewers.LabelProvider#getImage(java.lang.Object)
   */
  @Override
  public Image getImage(final Object element) {
    if (((File)element).isDirectory()) {
      return SWTResourceManager.getImage(Files.ICONS_FOLDER_GIF);
    } else if (((File)element).isFile()) {
      return SWTResourceManager.getImage(Files.ICONS_FILE_GIF);
    } else {
      return SWTResourceManager.getImage(Files.ICONS_CLOSE_GIF);
    }
  }
}
