/**
 * DuMP3 version 0.3.2 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate.gui.display.text;

import java.io.File;
import java.io.FileInputStream;

import net.za.grasser.duplicate.file.FingerprintFile;
import net.za.grasser.duplicate.gui.display.DoubleDisplay;
import net.za.grasser.duplicate.util.Strings;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.ScrollBar;
import org.eclipse.swt.widgets.ToolBar;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose whatever) then you should purchase a license for each developer using Jigloo. Please
 * visit www.cloudgarden.com for details. Use of Jigloo implies acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR THIS
 * MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * This class ...
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.4 $
 */
public class DoubleTextDisplay extends DoubleDisplay {
  /**
   * <code>canvasLeftText</code> DoubleTextDisplay -
   */
  private StyledText canvasLeftText;
  /**
   * <code>canvasRightText</code> DoubleTextDisplay -
   */
  private StyledText canvasRightText;
  /**
   * <code>toolBarMiddle</code> DoubleTextDisplay -
   */
  private ToolBar toolBarMiddle;

  /**
   * Constructor
   * 
   * @param pArg0
   * @param pArg1
   */
  public DoubleTextDisplay(final Composite pArg0, final int pArg1) {
    super(pArg0, pArg1);
    getCanvasLeftText();
    getToolBarMiddle();
    getCanvasRightText();
  }

  /**
   * @return canvasLeftText
   */
  public StyledText getCanvasLeftText() {
    if (canvasLeftText == null) {
      canvasLeftText = new StyledText(this, SWT.NO_BACKGROUND | SWT.NO_REDRAW_RESIZE | SWT.V_SCROLL | SWT.H_SCROLL);
      final FormData canvas5leftLData = new FormData();
      canvas5leftLData.width = 63;
      canvas5leftLData.height = 210;
      canvas5leftLData.left = new FormAttachment(0, 1000, 0);
      canvas5leftLData.right = new FormAttachment(500, 1000, -14);
      canvas5leftLData.top = new FormAttachment(0, 1000, 0);
      canvas5leftLData.bottom = new FormAttachment(1000, 1000, 0);
      canvasLeftText.setLayoutData(canvas5leftLData);
    }
    return canvasLeftText;
  }

  /**
   * @return canvasRightText
   */
  public StyledText getCanvasRightText() {
    if (canvasRightText == null) {
      canvasRightText = new StyledText(this, SWT.NO_BACKGROUND | SWT.NO_REDRAW_RESIZE | SWT.V_SCROLL | SWT.H_SCROLL);
      final FormData canvas5rightLData = new FormData();
      canvas5rightLData.width = 63;
      canvas5rightLData.height = 210;
      canvas5rightLData.left = new FormAttachment(500, 1000, 14);
      canvas5rightLData.right = new FormAttachment(1000, 1000, 0);
      canvas5rightLData.top = new FormAttachment(0, 1000, 0);
      canvas5rightLData.bottom = new FormAttachment(1000, 1000, 0);
      canvasRightText.setLayoutData(canvas5rightLData);
    }
    return canvasRightText;
  }

  /**
   * @return ToolBar
   */
  public ToolBar getToolBarMiddle() {
    if (toolBarMiddle == null) {
      toolBarMiddle = new ToolBar(this, SWT.WRAP | SWT.BORDER | SWT.VERTICAL);
      final FormData toolBar3LData = new FormData();
      toolBar3LData.width = 27;
      toolBar3LData.height = 112;
      toolBar3LData.left = new FormAttachment(500, 1000, -14);
      toolBar3LData.right = new FormAttachment(500, 1000, 14);
      toolBar3LData.top = new FormAttachment(0, 1000, 0);
      toolBar3LData.bottom = new FormAttachment(1000, 1000, 0);
      toolBarMiddle.setLayoutData(toolBar3LData);
    }
    return toolBarMiddle;
  }

  /**
   * This method load the file into a string
   * 
   * @param pFileName String
   * @return String
   */
  private String loadFile(final String pFileName) {
    try {
      // WARNING this will only read files up to MAXINT.
      final File file = new File(pFileName);
      final FileInputStream fi = new FileInputStream(file);
      int len;
      if (file.length() > Integer.MAX_VALUE) {
        len = Integer.MAX_VALUE;
      } else {
        len = (int)file.length();
      }
      final byte[] buffer = new byte[len];
      fi.read(buffer);
      fi.close();
      return new String(buffer);
    } catch (final Exception e) {
      return Strings.EMPTY;
    }
  }

  /**
   * This method displays two images
   * 
   * @param left
   * @param right
   */
  @Override
  public void display(final FingerprintFile left, final FingerprintFile right) {
    if (left == null) {
      getCanvasLeftText().setText(Strings.EMPTY);
    } else {
      getCanvasLeftText().setText(loadFile(left.getPath()));
    }
    if (right == null) {
      getCanvasRightText().setText(Strings.EMPTY);
    } else {
      getCanvasRightText().setText(loadFile(right.getPath()));
    }
  }

  /**
   * This method should return an instance of this class which does NOT initialize it's GUI elements. This method is ONLY required by Jigloo if the superclass
   * of this class is abstract or non-public. It is not needed in any other situation.
   * 
   * @param parent
   * @param style
   * @return Object
   */
  public static Object getGUIBuilderInstance(final org.eclipse.swt.widgets.Composite parent, final int style) {
    return new DoubleTextDisplay(parent, style, Boolean.FALSE);
  }

  /**
   * This constructor is used by the getGUIBuilderInstance method to provide an instance of this class which has not had it's GUI elements initialized (ie,
   * initGUI is not called in this constructor).
   * 
   * @param parent
   * @param style
   * @param initGUI
   */
  public DoubleTextDisplay(final org.eclipse.swt.widgets.Composite parent, final int style, final Boolean initGUI) {
    super(parent, style);
  }

  /**
   * This method keeps the left and right horizontal scroll bars in synch
   * 
   * @param img
   * @param pMinimum
   * @param pSelection
   * @param pMaximum
   */
  public void scrollX(final StyledText img, final int pMinimum, final int pSelection, final int pMaximum) {
    if (img == getCanvasLeftText()) {
      final ScrollBar r = getCanvasRightText().getHorizontalBar();
      double s = pSelection;
      s /= pMaximum - pMinimum;
      s *= r.getMaximum() - r.getMinimum();
      s += r.getMinimum();
      r.setSelection((int)s);
      // getCanvasRightText().scrollHorizontally(r, false);
    } else {
      final ScrollBar l = getCanvasLeftText().getHorizontalBar();
      double s = pSelection;
      s /= pMaximum - pMinimum;
      s *= l.getMaximum() - l.getMinimum();
      s += l.getMinimum();
      l.setSelection((int)s);
      // getCanvasLeftText().scrollHorizontally(l, false);
    }
  }

  /**
   * This method keeps the left and right vertical scroll bars in synch
   * 
   * @param img
   * @param pMinimum
   * @param pSelection
   * @param pMaximum
   */
  public void scrollY(final StyledText img, final int pMinimum, final int pSelection, final int pMaximum) {
    if (img == getCanvasLeftText()) {
      final ScrollBar r = getCanvasRightText().getVerticalBar();
      double s = pSelection;
      s /= pMaximum - pMinimum;
      s *= r.getMaximum() - r.getMinimum();
      s += r.getMinimum();
      r.setSelection((int)s);
      // getCanvasRightText().scrollVertically(r, false);
    } else {
      final ScrollBar r = getCanvasLeftText().getVerticalBar();
      double s = pSelection;
      s /= pMaximum - pMinimum;
      s *= r.getMaximum() - r.getMinimum();
      s += r.getMinimum();
      r.setSelection((int)s);
      // getCanvasLeftText().scrollVertically(r, false);
    }
  }
}
