/**
 * DuMP3 version 0.3.2 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate.gui.events;

/**
 * This class defines a hot-key that can be compared to an Event.
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.1 $
 */
public class HotKey implements Comparable<HotKey> {
  /**
   * <code>stateMask</code> HotKey -
   */
  public int stateMask = 0;
  /**
   * <code>keyCode</code> HotKey -
   */
  public int keyCode = 0;

  /**
   * Constructor
   * 
   * @param pStateMask
   * @param pKeyCode
   */
  public HotKey(int pStateMask, int pKeyCode) {
    stateMask = pStateMask;
    keyCode = pKeyCode;
  }

  /**
   * This method ...
   * 
   * @param pKey
   * @return int
   */
  public int compareTo(HotKey pKey) {
    if (pKey.stateMask == stateMask && pKey.keyCode == keyCode) {
      return 0;
    }
    return 1;
  }

  /**
   * @see java.lang.Object#equals(java.lang.Object)
   */
  @Override
  public boolean equals(Object pObj) {
    if (pObj instanceof HotKey) {
      return compareTo((HotKey)pObj) == 0;
    }
    return super.equals(pObj);
  }

  /**
   * @see java.lang.Object#hashCode()
   */
  @Override
  public int hashCode() {
    return (stateMask << 16) | keyCode;
  }
}
