/**
 * DuMP3 version 0.3.2 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate.gui.properties;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.widgets.Composite;

/**
 * This class defines a IProperty interface for use by the PropertyTableViewer
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.1 $
 */
public interface IProperty {
  /**
   * This method returns the property name
   * 
   * @return String
   */
  public abstract String getProperty();

  /**
   * This method returns the property value
   * 
   * @return String
   */
  public abstract String getValue();

  /**
   * This method sets the value of the property
   * 
   * @param pValue
   */
  public abstract void setValue(Object pValue);

  /**
   * This method gets the CellEditor defined for this Property
   * 
   * @param pComposite
   * @param style
   * @return CellEditor
   */
  public abstract CellEditor getCellEditor(Composite pComposite, int style);
}