/**
 * DuMP3 version 0.3.2 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate.util;

/**
 * This class contains the names of all the files in this project.
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.15 $
 */
public interface Files {
  /**
   * <code>A_COLON</code> Files -
   */
  public static final String A_COLON = "A:"; //$NON-NLS-1$
  /**
   * <code>B_COLON</code> Files -
   */
  public static final String B_COLON = "B:"; //$NON-NLS-1$
  /**
   * <code>BUNDLE_NAME</code> Files - "res.messages"
   */
  public static final String BUNDLE_NAME = "res.messages"; //$NON-NLS-1$
  /**
   * <code>DEBUG_BUNDLE_NAME</code> Files - "res.debug"
   */
  public static final String DEBUG_BUNDLE_NAME = "res.debug"; //$NON-NLS-1$
  /**
   * <code>SQL_BUNDLE_NAME</code> Files - "res.sql"
   */
  public static final String SQL_BUNDLE_NAME = "res.sql"; //$NON-NLS-1$
  /**
   * <code>CONFIG</code> Files - "./config.xml"
   */
  public static final String CONFIG = "./config.xml"; //$NON-NLS-1$
  /**
   * <code>ICONS_CLOSE_GIF</code> Files -
   */
  public static final String ICONS_CLOSE_GIF = "icons/close.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_COPY_INFO_LEFT_GIF</code> Files -
   */
  public static final String ICONS_COPY_INFO_LEFT_GIF = "icons/copy_info_left.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_COPY_INFO_RIGHT_GIF</code> Files -
   */
  public static final String ICONS_COPY_INFO_RIGHT_GIF = "icons/copy_info_right.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_FILE_GIF</code> Files -
   */
  public static final String ICONS_FILE_GIF = "icons/file.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_FOLDER_GIF</code> Files -
   */
  public static final String ICONS_FOLDER_GIF = "icons/folder.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_MAG_MIN_GIF</code> Files -
   */
  public static final String ICONS_MAG_MIN_GIF = "icons/mag_min.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_MAG_PLUS_GIF</code> Files -
   */
  public static final String ICONS_MAG_PLUS_GIF = "icons/mag_plus.gif"; //$NON-NLS-1$
  /**
   * <code>MAIN</code> Files -
   */
  public static final String ICONS_MAIN_ICO = "icons/main.ico"; //$NON-NLS-1$
  /**
   * <code>ICONS_MOVE_GIF</code> Files -
   */
  public static final String ICONS_MOVE_GIF = "icons/move.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_MOVE2_GIF</code> Files -
   */
  public static final String ICONS_MOVE2_GIF = "icons/move2.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_REMOVE_GIF</code> Files -
   */
  public static final String ICONS_REMOVE_GIF = "icons/remove.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_REMOVE2_GIF</code> Files -
   */
  public static final String ICONS_REMOVE2_GIF = "icons/remove2.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_SPLASH_GIF</code> Files -
   */
  public static final String ICONS_SPLASH_GIF = "icons/splash.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_TRASH_CAN_GIF</code> Files -
   */
  public static final String ICONS_TRASH_CAN_GIF = "icons/trash_can.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_TRASH_CAN2_GIF</code> Files -
   */
  public static final String ICONS_TRASH_CAN2_GIF = "icons/trash_can2.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_UNEQUAL_GIF</code> Files -
   */
  public static final String ICONS_UNEQUAL_GIF = "icons/unequal.gif"; //$NON-NLS-1$
  /**
   * <code>LOG4J</code> Files - "./log4j.properties"
   */
  public static final String LOG4J = "./log4j.properties"; //$NON-NLS-1$
  /**
   * <code>ICONS_OTHER_GIF</code> Files -
   */
  public static final String ICONS_OTHER_GIF = "icons/run.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_AUDIO_GIF</code> Files -
   */
  public static final String ICONS_AUDIO_GIF = "icons/note.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_IMAGE_GIF</code> Files -
   */
  public static final String ICONS_IMAGE_GIF = "icons/mona.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_BINARY_GIF</code> Files -
   */
  public static final String ICONS_BINARY_GIF = "icons/binary.gif"; //$NON-NLS-1$
  /**
   * <code>ICONS_TEXT_GIF</code> Files -
   */
  public static final String ICONS_TEXT_GIF = "icons/file.gif"; //$NON-NLS-1$
  /**
   * <code>NOTDUP_DAT</code> Files -
   */
  public static final String NOTDUP_DAT = "./notdup.dat"; //$NON-NLS-1$
  /**
   * <code>DATABASE_DAT</code> Files -
   */
  public static final String DATABASE_DAT = "./database.dat"; //$NON-NLS-1$
  /**
   * <code>VERSION_XML</code> Files -
   */
  public static final String VERSION_XML = "./version.xml"; //$NON-NLS-1$
  /**
   * <code>HTTP_VERSION_XML</code> Files -
   */
  public static final String HTTP_VERSION_XML = "http://dump3.sourceforge.net/version.xml"; //$NON-NLS-1$
}
