/**
 * DuMP3 version 0.3.2 - a duplicate/similar file finder in Java<BR>
 * Copyright 2005 Alexander Gr&auml;sser<BR>
 * All Rights Reserved, http://dump3.sourceforge.net/<BR>
 * <BR>
 * This file is part of DuMP3.<BR>
 * <BR>
 * DuMP3 is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later version.<BR>
 * <BR>
 * DuMP3 is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.<BR>
 * <BR>
 * You should have received a copy of the GNU General Public License along with DuMP3; if not, write to the Free Software Foundation, Inc., 51 Franklin St,
 * Fifth Floor, Boston, MA 02110-1301 USA
 */
package net.za.grasser.duplicate.util;

/**
 * This class contains common regular expression strings.
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.3 $
 */
public interface RegExs {
  /**
   * <code>DOT_STAR</code> RegExs -
   */
  public static final String DOT_STAR = ".*"; //$NON-NLS-1$
  /**
   * <code>STAR_DOT</code> RegExs -
   */
  public static final String STAR_DOT = "*."; //$NON-NLS-1$
  /**
   * <code>BSLASH_DOT</code> RegExs -
   */
  public static final String BSLASH_DOT = "\\."; //$NON-NLS-1$
  /**
   * <code>BSLASH_BSLASH_DOT</code> RegExs -
   */
  public static final String BSLASH_BSLASH_DOT = "\\\\."; //$NON-NLS-1$
  /**
   * <code>BSLASH_STAR</code> RegExs -
   */
  public static final String BSLASH_STAR = "\\*"; //$NON-NLS-1$
  /**
   * <code>BSLASH_QMARK</code> RegExs -
   */
  public static final String BSLASH_QMARK = "\\?"; //$NON-NLS-1$
  /**
   * <code>DOT_SLASH</code> RegExs -
   */
  public static final String DOT_SLASH = "./"; //$NON-NLS-1$
  /**
   * <code>BSLASH_OPN_BRACKET</code> RegExs -
   */
  public static final String BSLASH_OPN_BRACKET = "\\("; //$NON-NLS-1$
  /**
   * <code>BSLASH_CLS_BRACKET</code> RegExs -
   */
  public static final String BSLASH_CLS_BRACKET = "\\)"; //$NON-NLS-1$
  /**
   * <code>STAR_DOT_STAR</code> RegExs -
   */
  public static final String STAR_DOT_STAR = "*.*"; //$NON-NLS-1$
}
