package net.za.grasser.duplicate.util;

import java.util.StringTokenizer;

/**
 * This class ...
 * 
 * @author <a href="http://sourceforge.net/sendmessage.php?touser=733840">pyropunk at sourceforge dot net</a>
 * @version $Revision: 1.2 $
 */
public class Version implements Comparable<Version> {
  /**
   * <code>major</code> Version -
   */
  private int major = Integer.MAX_VALUE;
  /**
   * <code>minor</code> Version -
   */
  private int minor = Integer.MAX_VALUE;
  /**
   * <code>build</code> Version -
   */
  private int build = Integer.MAX_VALUE;

  /**
   * Constructor
   * 
   * @param s
   */
  public Version(final String s) {
    try {
      String t = s;
      if (t.indexOf(Chars.USCORE) >= 0) {
        t = t.substring(t.indexOf(Chars.USCORE) + 1);
      }
      final StringTokenizer st = new StringTokenizer(t, Strings.DOT);
      major = Integer.parseInt(st.nextToken());
      minor = Integer.parseInt(st.nextToken());
      build = Integer.parseInt(st.nextToken());
    } catch (final Exception t) {
      // ignore
    }
  }

  /**
   * @param pO
   * @return int
   * @see java.lang.Comparable#compareTo(java.lang.Object)
   */
  public int compareTo(final Version pO) {
    if ((major == pO.major) && (minor == pO.minor) && (build == pO.build)) {
      return 0;
    }
    if (major < pO.major) {
      return -1;
    }
    if (major > pO.major) {
      return 1;
    }
    if (minor < pO.minor) {
      return -1;
    }
    if (minor > pO.minor) {
      return 1;
    }
    if (build < pO.build) {
      return -1;
    }
    return 1;
  }

  /**
   * @see java.lang.Object#toString()
   */
  @Override
  public String toString() {
    return String.valueOf(major) + Strings.DOT + String.valueOf(minor) + Strings.DOT + String.valueOf(build);
  }
}
